#line 1 "D:/Projects/Haier/General Washer/workspace/General_Washer/General_Washer/src/disp_define.c"

void cpu_init(void);
void sfr_ref(void);
void sfr_init(void);
void ram_init(void);


void disp_key_power(void);				 
void disp_key_start(void);				 
void disp_key_setup(void);				 
 
void disp_key_confirm(void);			 
 
void disp_key_function(void);			 
void disp_key_program(void);			 
void disp_key_water(void);				 

void key_scan(void);					 
void key_judge(void);					 
void menu_display(void);				 
void display_status_judge (void);


 

union lcd_byte_def{

	unsigned char lcd_byte;

	struct{

	unsigned char lb0:1;
	unsigned char lb1:1;
	unsigned char lb2:1;
	unsigned char lb3:1;
	unsigned char lb4:1;
	unsigned char lb5:1;
	unsigned char lb6:1;
	unsigned char lb7:1;

	}lcd_bit;
};

union lcd_byte_def Lcd_Byte_0;
union lcd_byte_def Lcd_Byte_1;
union lcd_byte_def Lcd_Byte_2;

 


 


 
void process_flash(unsigned char, signed char, signed char, unsigned char, unsigned char, unsigned char);

 
void lcd_flash(unsigned char, unsigned char, unsigned char, unsigned char *, unsigned char *);

 
void menu_page_shift(unsigned char, unsigned char, unsigned char);


 
 

signed char epprom_4ms_buff;
unsigned char key_4ms_buff;
unsigned char Tflash;
unsigned char Pflash;
signed char scan_buff;
unsigned char scan_count;

unsigned char flash_flag;					 
unsigned char flash_switch_flag;			 
unsigned char Pflash_switch_flag;			 
unsigned char run_page3_flag;

signed char confirm_num;

signed char set_num;					 
signed char set_num_lev_0;				 
signed char set_num_lev_1;				 
signed char set_num_lev_2;				 
signed char set_num_lev_3;				 

 
 

unsigned char menu_level_buff;		 

unsigned char menu_level_3_back_flag;	 

unsigned char menu_buff_0;			 
unsigned char menu_buff_1;			 
unsigned char menu_buff_2;			 
unsigned char menu_buff_3;			 
unsigned char menu_buff_4;			 
unsigned char menu_buff_5;			 
unsigned char menu_buff_6;			 

 
 

unsigned char menu_0_flag;				 

 
 
 
 
 
 

unsigned char function_set_flag;			 
unsigned char program_set_flag;				 
unsigned char water_set_flag;				 
unsigned char power_flag;					 
unsigned char key_press_flag;				 


unsigned char first_water_flag;			 	
unsigned char first_soak_flag;			 
unsigned char first_wash_flag;			 
unsigned char first_rinse_flag;			 
unsigned char first_spin_flag;			 
unsigned char first_save_water_flag;			 
unsigned char first_wind_dry_flag;			 
unsigned char first_preset_flag;			 
unsigned char first_function_flag;

unsigned char confirm_water_flag;
unsigned char confirm_soak_flag;
unsigned char confirm_wash_flag;
unsigned char confirm_rinse_flag;
unsigned char confirm_spin_flag;
unsigned char confirm_save_water_flag;
unsigned char confirm_wind_dry_flag;
unsigned char confirm_preset_flag;
unsigned char confirm_function_flag;

unsigned char once_set_water_flag;
unsigned char once_set_soak_flag;
unsigned char once_set_wash_flag;
unsigned char once_set_rinse_flag;
unsigned char once_set_spin_flag;
unsigned char once_set_save_water_flag;
unsigned char once_set_wind_dry_flag;
unsigned char once_set_preset_flag;
unsigned char once_set_function_flag;

unsigned char num_overflow_flag;

unsigned char key_debunce_0;				 
unsigned char key_debunce_1;				 


 

unsigned char key_buff_0;			 
unsigned char key_buff_1;			 
 
unsigned int key_buff_2;			 
unsigned char key_buff_3;			 
unsigned char key_buff_4;			 

 
unsigned int save_key_1;			 
unsigned char save_key_2;			 

 

 
unsigned char left_time_buff;				 

 
 
 

unsigned char save_program_buff;
unsigned char rinse_three_time_flag;
unsigned char rinse_one_time_flag;

unsigned char program_buff_0;				 
unsigned char water_level_buff_0;			 
unsigned char soak_time_buff_0;
unsigned char wash_time_buff_0;
unsigned char rinse_time_buff_0;
unsigned char spin_time_buff_0;
unsigned char save_water_num_buff_0;
unsigned char winddry_time_buff_0;
unsigned char preset_time_buff_0;
unsigned char function_set_buff_0;

 
 
unsigned char soak_time_buff;
unsigned char wash_time_buff;
unsigned char rinse_time_buff;
unsigned char spin_time_buff;
unsigned char save_water_num_buff;
unsigned char winddry_time_buff;
unsigned char preset_time_buff;
unsigned char function_set_buff;


unsigned char program_start_flag;		 
unsigned char program_pause_flag;		 

unsigned char preset_set_flag;

