#ifndef __DISP_DEFINE_H__
#define __DISP_DEFINE_H__


/************************************************************************
 #define	Key_03	0x01
 #define	Key_04	0x04
 #define	Key_05	0x10
 #define	Key_06	0x40
 #define	Key_07	0x40
 #define	Key_12	0x02
 #define	Key_13	0x08
 #define	Key_14	0x20
 #define	Key_15	0x80
************************************************************************/

 #define	Key_1	0x02
 #define	Key_2	0x08
 #define	Key_3	0x20
 #define	Key_4	0x80
 #define	Key_5	0x01
 #define	Key_6	0x04
 #define	Key_7	0x10
 #define	Key_8	0x40
 #define	Key_9	0xc0
 
// sw4 | sw8 | sw3 | sw7 | sw2 | sw6 | sw1 | sw5

/////////////////////////////////////////////////////////////////////////
 
 #define	Key_Program		Key_6
 #define	Key_Function	Key_7
 #define	Key_Water		Key_8
 #define	Key_Power		Key_5
 #define	Key_Start		Key_9
 #define	Key_SetUp		Key_1
 #define	Key_SetDown		Key_2
 #define	Key_Cancel		Key_3
 #define	Key_OK			Key_4 
 
 #define	Inlet			0x00				// ʾǰйΪˮ
 #define	Soak			0x01				// ʾǰйΪ			
 #define	Wash			0x02				// ʾǰйΪϴ
 #define	Rinse			0x03				// ʾǰйΪƯϴ
 #define	Spin			0x04				// ʾǰйΪˮ
 #define	Preset			0x05				// ʾǰйΪԤԼ
 #define	Tubedry			0x06 				// ʾǰйΪͰ
 
/****************************************************************/

 #define	Menu_Level_0		0x00				// ˵0
 #define	Menu_Level_1		0x01				// ˵1 
 #define	Menu_Level_2		0x02				// ˵2
 #define	Menu_Level_3		0x03				// ˵3
 #define	Menu_Level_4		0x04				// ˵4 
 #define	Menu_Level_5		0x05				// ˵5
 #define	Menu_Level_6		0x06				// ˵6 
 
 
// #define	Menu_Program_0		0x60
// #define	Menu_Program_1		0x61 
 
// #define	Menu_Program_2		0x70
// #define	Menu_Program_3		0x71
   
// #define	Menu_Water			0x0d

  
 #define	Menu_Memo			0x10				// ò˵
 #define	Menu_Strong			0x11				// ǿò˵
 #define	Menu_Soft			0x12				// ò˵
 #define	Menu_Quick			0x13				// ٳò˵
 #define	Menu_Standard		0x14				// ׼ò˵  
 #define	Menu_Child			0x15				// ͯò˵
 #define	Menu_Wood			0x16				// ë֯Ʒò˵
 #define	Menu_Silk			0x17				// ˿֯Ʒò˵  
 
 #define	Menu_Wash_Set		0x18				// ϴò˵
 #define	Menu_Rinse_Set		0x19				// Ưò˵
 #define	Menu_Spin_Set		0x1a				// ѳò˵
 #define	Menu_Special		0x1b				// ò˵

 #define	Menu_Water_P		0x20 				// ˮλò˵

 #define	Menu_Soak_Time		0x21 				// ʱò˵
 #define	Menu_Wash_Time		0x22 				// ϴʱò˵
 #define	Menu_Rinse_Num		0x23 				// Ưϴʱò˵
 #define	Menu_Spin_Time		0x24 				// ˮʱò˵
 #define	Menu_Save_Water		0x25 				// ˮò˵
// #define	Menu_Wind_Dry		0x26
 #define	Menu_Preset			0x26 				// ԤԼʱò˵
// #define	Menu_Preset			0x27
 #define	Menu_Function		0x28 				// ò˵
 
//---------------------------------------------------------------------------------

#define		function_set_flag		key_flag_1.f_bit.fb0	/* ܼ±־ */
#define		program_set_flag		key_flag_1.f_bit.fb1	/* ±־ */
#define		water_set_flag			key_flag_1.f_bit.fb2	/* ˮλ±־ */
#define		power_flag				key_flag_1.f_bit.fb3	/* Դ±־ */
#define		key_press_flag			key_flag_1.f_bit.fb4	/* ±־ */

//---------------------------------------------------------------------------------

#define		run_page3_flag				display_flag_1.f_bit.fb0	/* 3 ˵ʾ־ */
#define		menu_level_3_back_flag		display_flag_1.f_bit.fb1	/* 3 ˵ر־ */
#define		menu_0_flag					display_flag_1.f_bit.fb2	/* ǰΪ 0 ˵־ */
#define		num_overflow_flag			display_flag_1.f_bit.fb3	/* 趨ޱ־ */
#define		rinse_three_time_flag		display_flag_1.f_bit.fb4	/* 3 Ưϴ־ */
#define		rinse_one_time_flag			display_flag_1.f_bit.fb5	/* 1 Ưϴ־ */
#define		program_start_flag			display_flag_1.f_bit.fb6	/* ־ */
#define		program_pause_flag			display_flag_1.f_bit.fb7	/* ͣ־ */
#define		preset_set_flag				display_flag_1.f_bit.fb8	/* ԤԼѡ־ */

//---------------------------------------------------------------------------------

#define		first_water_flag		first_key_press.f_bit.fb0	/* һˮλ趨־ */
#define		first_soak_flag			first_key_press.f_bit.fb1	/* һνʱ趨־ */
#define		first_wash_flag			first_key_press.f_bit.fb2	/* һϴʱ趨־ */
#define		first_rinse_flag		first_key_press.f_bit.fb3	/* һƯϴ趨־ */
#define		first_spin_flag			first_key_press.f_bit.fb4	/* һˮʱ趨־ */
#define		first_save_water_flag	first_key_press.f_bit.fb5	/* һˮ趨־ */
#define		first_wind_dry_flag		first_key_press.f_bit.fb6	/* һηʱ趨־ */
#define		first_preset_flag		first_key_press.f_bit.fb7	/* һԤԼ趨־ */
#define		first_function_flag		first_key_press.f_bit.fb8	/* һι趨־ */


#define		confirm_water_flag			confirm_key_press.f_bit.fb0	/* һˮλ趨־ */
#define		confirm_soak_flag			confirm_key_press.f_bit.fb1	/* һνʱ趨־ */
#define		confirm_wash_flag			confirm_key_press.f_bit.fb2	/* һϴʱ趨־ */
#define		confirm_rinse_flag			confirm_key_press.f_bit.fb3	/* һƯϴ趨־ */
#define		confirm_spin_flag			confirm_key_press.f_bit.fb4	/* һˮʱ趨־ */
#define		confirm_save_water_flag		confirm_key_press.f_bit.fb5	/* һˮ趨־ */
#define		confirm_wind_dry_flag		confirm_key_press.f_bit.fb6	/* һηʱ趨־ */
#define		confirm_preset_flag			confirm_key_press.f_bit.fb7	/* һԤԼ趨־ */
#define		confirm_function_flag		confirm_key_press.f_bit.fb8	/* һι趨־ */


#define		once_set_water_flag			once_set_key_press.f_bit.fb0	/* һˮλ趨־ */
#define		once_set_soak_flag			once_set_key_press.f_bit.fb1	/* һνʱ趨־ */
#define		once_set_wash_flag			once_set_key_press.f_bit.fb2	/* һϴʱ趨־ */
#define		once_set_rinse_flag			once_set_key_press.f_bit.fb3	/* һƯϴ趨־ */
#define		once_set_spin_flag			once_set_key_press.f_bit.fb4	/* һˮʱ趨־ */
#define		once_set_save_water_flag	once_set_key_press.f_bit.fb5	/* һˮ趨־ */
#define		once_set_wind_dry_flag		once_set_key_press.f_bit.fb6	/* һηʱ趨־ */
#define		once_set_preset_flag		once_set_key_press.f_bit.fb7	/* һԤԼ趨־ */
#define		once_set_function_flag		once_set_key_press.f_bit.fb8	/* һι趨־ */


/****************************************************************/

extern void cpu_init(void);					/* CPU ʼ */
extern void sfr_ref(void);					/* ⹦ܼĴˢ³ */
extern void sfr_init(void);					/* ⹦ܼĴʼ */
extern void ram_init(void);					/* RAM ʼ */


extern void disp_key_power(void);				/* Դ */
extern void disp_key_start(void);				/* ʼ */
extern void disp_key_setup(void);				/* ü (+, -) */
//extern void disp_key_setdown(void);
extern void disp_key_confirm(void);				/* ȷϣؼ */
//extern void disp_key_back(void);
extern void disp_key_function(void);			/* ܼ */
extern void disp_key_program(void);				/*  */
extern void disp_key_water(void);				/* ˮλ */

extern void key_scan(void);						/* ɨ */
extern void key_judge(void);					/* ߼ */
extern void menu_display(void);					/* ˵ʾ */
extern void display_status_judge (void);

//extern void lcd_disp(unsigned char *);


/* в˵ʾ */
extern void process_flash(unsigned char, signed char, signed char, unsigned char, unsigned char, unsigned char);

/* г趨ʱ˸ */
extern void lcd_flash(unsigned char, unsigned char, unsigned char, unsigned char far *, unsigned char far *);

/* ˵ҳ */
extern void menu_page_shift(unsigned char, unsigned char, unsigned char);

/****************************************************************/

extern unsigned char power_down_byte;		/* ϵͳ״̬ */

/****************************************************************
  Һӿڶ
****************************************************************/

 union lcd_byte_def{

	unsigned char lcd_byte;

	struct{

	unsigned char lb0:1;
	unsigned char lb1:1;
	unsigned char lb2:1;
	unsigned char lb3:1;
	unsigned char lb4:1;
	unsigned char lb5:1;
	unsigned char lb6:1;
	unsigned char lb7:1;

	}lcd_bit;
};


extern union lcd_byte_def Lcd_Byte_0;		/* LCD ʾ 0 */
extern union lcd_byte_def Lcd_Byte_1;		/* LCD ʾ 1 */
extern union lcd_byte_def Lcd_Byte_2;		/* LCD ʾ 2 */

/****************************************************************
  Һӿڶ
****************************************************************/

typedef  union flag_word_def{

	unsigned int f_word;

	struct{

	unsigned char fb0:1;
	unsigned char fb1:1;
	unsigned char fb2:1;
	unsigned char fb3:1;
	unsigned char fb4:1;
	unsigned char fb5:1;
	unsigned char fb6:1;
	unsigned char fb7:1;
	unsigned char fb8:1;	
	
	unsigned char fb9_15:7;
	
	}f_bit;
	
}Word_Flag;


extern 	Word_Flag 	first_key_press;				/* 趨һΰ־ */
extern 	Word_Flag 	confirm_key_press;				/* 趨ȷϰ־ */
extern 	Word_Flag 	once_set_key_press;				/* 趨־ */

extern 	Word_Flag 	display_flag_1;					/* ʾ־ */

extern 	Word_Flag 	process_flag_1;					/* ̱־ 1 */
extern 	Word_Flag 	process_flag_2;					/* ̱־ 2 */

//---------------------------------------------------------------

typedef  union flag_byte_def{

	unsigned int f_byte;

	struct{

	unsigned char fb0:1;
	unsigned char fb1:1;
	unsigned char fb2:1;
	unsigned char fb3:1;
	unsigned char fb4:1;
	unsigned char fb5:1;
	unsigned char fb6:1;
	unsigned char fb7:1;
	
	}f_bit;
	
}Byte_Flag;

extern 	Byte_Flag 	key_flag_1;							/* ־ֽ 1 */
extern 	Byte_Flag 	key_flag_2;							/* ־ֽ 2 */

extern 	Byte_Flag 	operation_flag_1;					/* ֽ 1 */
extern 	Byte_Flag 	operation_flag_2;					/* ֽ 2 */
extern 	Byte_Flag 	operation_flag_3;					/* ֽ 3 */
extern 	Byte_Flag 	operation_flag_4;					/* ֽ 4 */
extern 	Byte_Flag 	operation_flag_5;					/* ֽ 5 */

extern 	Byte_Flag 	save_water_flag_1;					/* ˮ־ֽ 1 */


extern 	Byte_Flag 	test1_flag_1;						/*  1 ־ֽ 1 */

extern 	Byte_Flag 	test1_key_flag;						/*  1 ־ֽ 1 */
extern 	Byte_Flag 	test2_key_flag;						/*  2 ־ֽ 2 */
extern 	Byte_Flag 	test3_key_flag;						/*  3 ־ֽ 3 */
extern 	Byte_Flag 	test4_key_flag;						/*  4 ־ֽ 4 */
extern 	Byte_Flag 	test5_key_flag;						/*  5 ־ֽ 5 */

extern 	Byte_Flag 	buzz_flag_1;						/* ־ֽ 1 */

/****************************************************************/

extern signed char epprom_4ms_buff;						/* EEPROM д 4 ms ʱ */
extern unsigned char key_4ms_buff;						/* ɨ 4 ms ʱ */
extern unsigned char Tflash;							/* 趨˸ʱ */
extern unsigned char Pflash;							/* ״̬˸ʱ */
extern signed char scan_buff;							/* ɨݴ */
extern unsigned char scan_count;						/* ɨƱ */

extern unsigned char flash_flag;					/* ˸־ */
extern unsigned char flash_switch_flag;				/* ˸л־ */
extern unsigned char Pflash_switch_flag;			/* в˵˸л־ */

extern signed char confirm_num;						/* ˮȷϱ */

extern signed char set_num;						/* ðӼ */
extern signed char set_num_lev_0;				/* 0 ˵ʱӼ */
extern signed char set_num_lev_1;				/* 1 ˵ʱӼ */
extern signed char set_num_lev_2;				/* 2 ˵ʱӼ */
extern signed char set_num_lev_3;				/* 3 ˵ʱӼ */

extern unsigned char menu_level_buff;		/* ˵ */

extern unsigned char menu_buff_0;			/* 0 ˵ */
extern unsigned char menu_buff_1;			/* 1 ˵ */
extern unsigned char menu_buff_2;			/* 2 ˵ */
extern unsigned char menu_buff_3;			/* 3 ˵ */
extern unsigned char menu_buff_4;			/* 4 ˵ */
extern unsigned char menu_buff_5;			/* 5 ˵ */
extern unsigned char menu_buff_6;			/* 6 ˵ */

extern unsigned char key_debunce_0;				/* ȥ0 */
extern unsigned char key_debunce_1;				/* ȥ1 */


/* sw715 | sw706 | sw714 | sw705 | sw713 | sw704 | sw712 | sw703 */

extern unsigned char key_buff_0;			/*  0 */
extern unsigned char key_buff_1;			/*  1 */
//extern unsigned char key_buff_2;			/*  2 */
extern unsigned int key_buff_2;			/*  2, ںϴ¹ģӿ */
extern unsigned char key_buff_3;			/*  3 */
extern unsigned char key_buff_4;			/*  4 */

//extern unsigned char save_key_1;			/* ֵ 1൱ old key  */
extern unsigned int save_key_1;			/* ֵ 1൱ old key  */
extern unsigned char save_key_2;			/* ֵ 2 */

extern unsigned char left_time_buff;				/* ʣʱ */

extern unsigned char save_program_buff;

extern unsigned char program_buff_0;				/* 洢 0 */
extern unsigned char water_level_buff_0;			/* ˮλ洢 0 */
extern unsigned char soak_time_buff_0;				/* ʱ洢 0 */
extern unsigned char wash_time_buff_0;				/* ϴʱ洢 0 */
extern unsigned char rinse_time_buff_0;				/* Ưϴʱ洢 0 */
extern unsigned char spin_time_buff_0;				/* ˮʱ洢 0 */
extern unsigned char save_water_num_buff_0;			/* ˮ洢 0 */
extern unsigned char winddry_time_buff_0;			/* ʱ洢 0 */
extern signed char preset_time_buff_0;				/* ԤԼʱ洢 0 */
extern unsigned char function_set_buff_0;			/* ѡ洢 0 */

extern unsigned char soak_time_buff;				/* ʱ洢 1 */
extern unsigned char wash_time_buff;				/* ϴʱ洢 1 */
extern unsigned char rinse_time_buff;				/* Ưϴ洢 1 */
extern unsigned char spin_time_buff;				/* ˮʱ洢 1 */
extern unsigned char save_water_num_buff;			/* ˮ洢 1 */
extern unsigned char winddry_time_buff;				/* ʱ洢 1 */
extern signed char preset_time_buff;				/* ԤԼʱ洢 1 */
extern unsigned char function_set_buff;				/* ѡ洢 1 */


#endif


