
#include "sfr_r82b.h"
#include "main.h"


void operation(void)
{
	unsigned char i;
	unsigned char j;
	
	i = operation_buff;
	
	i &= 0xf7;
	
	switch (i)
	 {
		 case 0:
		 
		 j = operation_buff;
		 j >> 3;
		 j &= 0x03;
		 if (j == 1)
		  {
			  table_rom_number = 0;
			  
			  j >> 2;
			  
//			  soak_time = Common_Soak_Time_Table[j];
//			  wash_time = Common_Wash_Time_Table[j];  

		  }
		 else if (j == 2)
		  {
			  table_rom_number = 1;
//			  wash_time = dependant_wash_time; 
		  }
		 else if (j ==3)
		  {
			  table_rom_number = manual_process_buff + 2;
//			  wash_time = dependant_wash_time; 
		  }	 
		 common_program();
		 break;
		 
		 case 1:
		 
		 speedy_program();
		 break;
		 
		 case 2:
		 
		 fastest_program();
		 break;
		 
		 case 3:
		 
		 j = operation_buff;
		 j >> 3;
		 j &= 0x03;
		 if (j == 1)
		  {
			  table_rom_number = 0;
			  
			  j >> 2;
			  
//			  soak_time = Common_Soak_Time_Table[j];
//			  wash_time = Common_Wash_Time_Table[j];  

		  }
		 else if (j == 2)
		  {
			  table_rom_number = 1;
//			  wash_time = dependant_wash_time; 
		  }
		 else if (j ==3)
		  {
			  table_rom_number = manual_process_buff + 2;
//			  wash_time = dependant_wash_time; 
		  }	 
		  
		 jeans_program();
		 break;
		 
		 
		 case 4:
		 
		 j = operation_buff;
		 j >> 3;
		 j &= 0x03;
		 if (j == 1)
		  {
			  table_rom_number = 0;
			  
			  j >> 2;
			  
//			  soak_time = Common_Soak_Time_Table[j];
//			  wash_time = Common_Wash_Time_Table[j];  

		  }
		 else if (j == 2)
		  {
			  table_rom_number = 1;
//			  wash_time = dependant_wash_time; 
		  }
		 else if (j ==3)
		  {
			  table_rom_number = manual_process_buff + 2;
//			  wash_time = dependant_wash_time; 
		  }	 
		  
		 standard_program();
		 break;
		 
		 case 5:
		 
		 j = operation_buff;
		 j >> 3;
		 j &= 0x03;
		 if (j == 1)
		  {
			  table_rom_number = 0;
			  
			  j >> 2;
			  
//			  soak_time = Common_Soak_Time_Table[j];
//			  wash_time = Common_Wash_Time_Table[j];  

		  }
		 else if (j == 2)
		  {
			  table_rom_number = 1;
//			  wash_time = dependant_wash_time; 
		  }
		 else if (j ==3)
		  {
			  table_rom_number = manual_process_buff + 2;
//			  wash_time = dependant_wash_time; 
		  }	 
		  
		 fiber_program();
		 break;
		 
		 case 6:
		 
		 j = operation_buff;
		 j >> 3;
		 j &= 0x03;
		 if (j == 1)
		  {
			  table_rom_number = 0;
			  
			  j >> 2;
			  
//			  soak_time = Common_Soak_Time_Table[j];
//			  wash_time = Common_Wash_Time_Table[j];  

		  }
		 else if (j == 2)
		  {
			  table_rom_number = 1;
//			  wash_time = dependant_wash_time; 
		  }
		 else if (j ==3)
		  {
			  table_rom_number = manual_process_buff + 2;
//			  wash_time = dependant_wash_time; 
		  }	 
		  
		 cotton_program();
		 break;
		 
		 case 7:
		 
		 tubedry_program();
		 break;
		 
	 };
	
  return;
	
}

/******************************************************************************************


******************************************************************************************/

void common_program(void)
{
	if (Common_Time_Table[table_rom_number][operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0:
			  case 19: inlet(0, 0, NORMAL); 
			  break;
			  
			  case 6:  inlet(0, 0, NORMAL);
			  break;
			  
			  case 1:  soak(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 2:
			  case 20: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 4:
			  case 14:
			  case 22: drain();
			  break;
			  
			  case 5:
			  case 15:
			  case 23: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 16:
			  case 24: spin(Common_Time_Table[table_rom_number][operation_counter]);

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void standard_program(void)
{
	if (Standard_Time_Table[table_rom_number][operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0:  inlet(0, 0, NORMAL); 
			  break;
			  
			  case 6:  inlet(0, 0, NORMAL);
			  break;
			  
			  case 1:  soak(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 2:  wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 4:  drain();
			  break;
			  
			  case 5:  interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 14: spin(Common_Time_Table[table_rom_number][operation_counter]);

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void jeans_program(void)
{
	if (Jeans_Time_Table[table_rom_number][operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0:  
			  case 9:
			  case 17: inlet(0, 0, NORMAL); 
			  break;
			  
			  case 1:  soak(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 2:  
			  case 10:
			  case 18: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 4:  
			  case 12:
			  case 20: drain();
			  break;
			  
			  case 5:  
			  case 13:
			  case 21: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 6: 
			  case 14:
			  case 22: spin(Common_Time_Table[table_rom_number][operation_counter]);

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void fiber_program(void)
{
	if (Fiber_Time_Table[table_rom_number][operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0:  
			  case 9:
			  case 16: inlet(0, 0, NORMAL); 
			  break;
			  
			  case 1:  soak(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 2:  
			  case 10:
			  case 17: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 4:  
			  case 11:
			  case 18: drain();
			  break;
			  
			  case 5:  
			  case 12:
			  case 19: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 6: 
			  case 13:
			  case 20: spin(Common_Time_Table[table_rom_number][operation_counter]);

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void cotton_program(void)
{
	if (Cotton_Time_Table[table_rom_number][operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0:  
			  case 9:
			  case 17: 
			  case 25: inlet(0, 0, NORMAL); 
			  break;
			  
			  case 1:  soak(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 2:  
			  case 10:
			  case 18: 
			  case 26: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 4:  
			  case 12:
			  case 20: 
			  case 28: drain();
			  break;
			  
			  case 5:  
			  case 13:
			  case 21: 
			  case 29: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 6: 
			  case 14:
			  case 22: 
			  case 30: spin(Common_Time_Table[table_rom_number][operation_counter]);

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void speedy_program(void)
{
	if (Speedy_Time_Table[operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0: inlet(0, 0, SPEEDY); 
			  break;
			  
			  case 9: inlet(0, 0, SPEEDY);
			  break;
			  
			  case 3:  
			  case 4:
			  case 5: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 7: drain();
			  break;
			  
			  case 8: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 16: inertial();
			  break;
			  
			  case 18: spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 21: buzz();

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void fastest_program(void)
{
	if (Fastest_Time_Table[operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0: inlet(0, 0, FASTEST); 
			  break;
			  
			  case 7: inlet(0, 0, FASTEST);
			  break;

			  case 3: wash(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 5: 
			  case 12: drain();
			  break;
			  
			  case 6: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 10: inertial();
			  break;
			  
			  case 13: spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 16: buzz();

		  }
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

/******************************************************************************************


******************************************************************************************/

void tubedry_program(void)
{
	if (TubeDry_Time_Table[operation_counter])
	 {
		 switch (operation_counter)
		  {
			  case 0: 
			  case 2:
			  case 4: interm_spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 1: 
			  case 3:
			  case 5: spin(Common_Time_Table[table_rom_number][operation_counter]);
			  break;
			  
			  case 6: buzz();

		  };
		  
		return;
		 
	 }
	 
	else 
	operation_counter ++;
	return;
	
}

