
#include "sfr_r82b.h"
#include "s6b0108.h"
#include "disp_definel.h"


void Delay(int);									/*  ʱӳ  */
void Long_Delay(int);						/*  ʱӳ  */
void Write_0108_Reg(unsigned char);				/*  KS0108Ĵд뺯  */
void Write_0108_Data(unsigned char);				/*  KS0108ʾд뺯  */
void Set_XY(unsigned char, unsigned char);		/*  õַXԵΪλYpageΪλ  */
void Init_0108();									/*  KS0108Ĵʼ  */
void Clr_Screen_0();								/*  KS0108ʾ洢  */
void Clr_Screen_1();
void Clr_Screen_2();
void Set_Screen3();								/*  KS0108ʾ洢  */

void Set_Screen(unsigned char, unsigned char far *);
void Comp_Set_Screen(unsigned char, unsigned char, unsigned char, unsigned char far *);
//void Set_Page(unsigned char, unsigned char, unsigned char *);
void Set_Caracter(unsigned char, unsigned char, unsigned char, unsigned char far *);
void Set_Char(unsigned char, unsigned char, unsigned char, unsigned char far *);
void FSH_Set_Two_Page(unsigned char, unsigned char, unsigned char far *);

unsigned char Read_0108_Data();				/*  ȡKS0108ʾݺ  */
unsigned char Data_Convert(unsigned char);	/*  ݰнת  */

/****************************************************************

union lcd_byte_def{

	unsigned char lcd_byte;

	struct{

	unsigned char lb0:1;
	unsigned char lb1:1;
	unsigned char lb2:1;
	unsigned char lb3:1;
	unsigned char lb4:1;
	unsigned char lb5:1;
	unsigned char lb6:1;
	unsigned char lb7:1;

	}lcd_bit;
};

union lcd_byte_def Lcd_Byte_0;
union lcd_byte_def Lcd_Byte_1;
union lcd_byte_def Lcd_Byte_2;

****************************************************************/

/****************************************************************
  ʱӳ
****************************************************************/

void Delay(int t)
{
	while(--t);
}

/****************************************************************
  ʱӳ
****************************************************************/

void Long_Delay(int t)
{
	int n = 0xff;
	
	while(--t)
	{
		while(--n);
		n = 0xff;
	}
}

/****************************************************************

unsigned char Data_Convert(unsigned char lcd_data)

תӲ·صLCDʾ

****************************************************************/

unsigned char Data_Convert(unsigned char lcd_data)
{
  Lcd_Data_0 = lcd_data;
  Lcd_Data_1 = lcd_data;
  
  Lcd_Data_0 &= 0x0f;
  Lcd_Data_1 &= 0xf0;
    
  Lcd_Bit_7 = Lcd_Bit_0;						/* LCDʾݸߵλ */
  Lcd_Bit_6 = Lcd_Bit_1;  
  Lcd_Bit_5 = Lcd_Bit_2;
  Lcd_Bit_4 = Lcd_Bit_3;
  
  Lcd_Data_0 &= 0xf0;
  
  Lcd_Data_0 = Lcd_Data_0 >> 4;	   
  Lcd_Data_2 = Lcd_Data_0 |  Lcd_Data_1;	 	/* ɵLCDʾ */

  return Lcd_Data_2;							/* LCD */
  
}

/****************************************************************

void Write_0108_Reg(unsigned char Reg_Code)

KS0108Ĵд뺯ڿƶLCDĲ

****************************************************************/

void Write_0108_Reg(unsigned char Reg_Code)
{
	unsigned char bus_low;
	unsigned char bus_high;
	
	bus_low = bus_high = Data_Convert(Reg_Code);		/* LCDReg_Code */
	
	bus_low &= 0x0f;				/* λ */
	bus_high &= 0xf0;
	
	bus_high = bus_high >> 4;		
		
	DI = 0;							/*  */
//	RW = 0;
	Lcd_Bus_L &= 0xf0;
	Lcd_Bus_H &= 0xf0;
	Lcd_Bus_L |= bus_low;
	Lcd_Bus_H |= bus_high;
	E = 1;
	E = 0;
}

/****************************************************************

void Write_0108_Data(unsigned char Bus_Data)

KS0108ʾд뺯

****************************************************************/

void Write_0108_Data(unsigned char Bus_Data)
{
	unsigned char bus_low;
	unsigned char bus_high;
	
	bus_low = bus_high = Data_Convert(Bus_Data);		/* LCDʾݣBus_Data */
	
	bus_low &= 0x0f;
	bus_high &= 0xf0;
	
	bus_high = bus_high >> 4;
			
	DI = 1;						/* ʾ */
//	E = 1;
//	RW = 0;
	Lcd_Bus_L &= 0xf0;
	Lcd_Bus_H &= 0xf0;
	Lcd_Bus_L |= bus_low;
	Lcd_Bus_H |= bus_high;
	E = 1;
//	asm("nop");
	E = 0;
}

/****************************************************************

unsigned char Read_0108_Data()

ȡKS0108ʾݺ 

****************************************************************/

unsigned char Read_0108_Data()
{
	unsigned char Bus_Data_0;
	unsigned char Bus_Data_1;
	
	DI = 1;
//	RW = 1;
	Lcd_Bus_L &= 0xf0;
	Lcd_Bus_H &= 0xf0;	
	E = 1;						/* ݵַ */
	Bus_Data_1 = Lcd_Bus_H;
	Bus_Data_0 = Lcd_Bus_L;
	E = 0;						/* ʾݶ */
	
	Bus_Data_1 = Bus_Data_1 << 4;	
	Bus_Data_0 &= 	0xf0;
	Bus_Data_0 |= Bus_Data_1;
	
	return Bus_Data_0;
	
}

/****************************************************************

void Set_XY(unsigned char X_Column,  unsigned char Y_Page)

õַXԵΪλYpageΪλ
  
****************************************************************/

void Set_XY(unsigned char X_Column,  unsigned char Y_Page)
{
	Write_0108_Reg(Set_Page+Y_Page);
	Write_0108_Reg(Set_Column+X_Column);
}

/****************************************************************

void Init_0108()

KS0108Ĵʼ
  
****************************************************************/

void Init_0108()
{
	Delay(100);
	CSA=0;					/* ʼʾ0 */
	CSB=0;
	Delay(100);
	Write_0108_Reg(Set_Disp_Off);
	Write_0108_Reg(Set_Start_Line);
	Write_0108_Reg(Set_Page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Disp_On);
	Delay(100);
	CSA=0;					/* ʼʾ1 */
	CSB=1;
	Delay(100);
	Write_0108_Reg(Set_Disp_Off);
	Write_0108_Reg(Set_Start_Line);
	Write_0108_Reg(Set_Page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Disp_On);
	Delay(100);
	CSA=1;					/* ʼʾ2 */
	CSB=0;
	Delay(100);
	Write_0108_Reg(Set_Disp_Off);
	Write_0108_Reg(Set_Start_Line);
	Write_0108_Reg(Set_Page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Disp_On);
		
}


/****************************************************************

void Clr_Screen_0()

KS0108ʾ 0 洢
  
****************************************************************/
void Clr_Screen_0()
{
	unsigned char j, k;
	unsigned int n=0;

	CSA=0;
	CSB=0;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);				/* ʼҳ */
		Write_0108_Reg(Set_Column);				/* ʼ */
		Write_0108_Reg(Set_Start_Line_0);		/* ʼ */
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(0x00);				/* ʱдֵΪ0 */
			n++;
		}
		
	}
}

/****************************************************************

void Clr_Screen_1()

KS0108ʾ 1 洢
  
****************************************************************/

void Clr_Screen_1()
{
	unsigned char j, k;
	unsigned int n=0;

	CSA=0;
	CSB=1;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		Write_0108_Reg(Set_Start_Line_0);
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(0x00);
			n++;
		}
		
	}
}

/****************************************************************

void Clr_Screen_2()

KS0108ʾ 2 洢
  
****************************************************************/

void Clr_Screen_2()
{
	unsigned char j, k;
	unsigned int n=0;

	CSA=1;
	CSB=0;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);		
		Write_0108_Reg(Set_Start_Line_0);
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(0x00);
			n++;
		}
		
	}
}

/******************************************************************************************************

void Set_Char(unsigned char cs, unsigned char page, unsigned char num, unsigned char far * bitmap)

ַ

cs: ҪַҺCS1, CS2  CS3;

page: Ҫַʼҳ

num: ַǰĿոλΪ

bitmapݱַ
  
******************************************************************************************************/

void Set_Char(unsigned char cs, unsigned char page, unsigned char num, unsigned char far * bitmap)		// num = 0,7;
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	unsigned char a,b;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);	
	
	Write_0108_Reg(Set_Page + page);					/* ʼҳ */
	Write_0108_Reg(Set_Column + num);					/* ʼ */
	Write_0108_Reg(Set_Start_Line_0);					/* ʼ */
	
	if (page == 2)					/* ҪʾҳΪ2ҳʱҪ˵߿Ҫַ 0x01 л */
	 {
		for(j=0;j<8;j++) 
	 	 {
			 
			b = bitmap[n];
			a = b | 0x01;
			Write_0108_Data(a);					
			n++;
	 	 }
	 }
	else 
	 {
		for(j=0;j<8;j++) 
	 	 {
			Write_0108_Data(bitmap[n]);
			n++;
	 	 }		 
	 }
	
	page += 1;
	
	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column + num);
	
	if (page == 7)					/* ҪʾҳΪ7ҳʱҪ˵߿Ҫַ 0x08 л */
	 {
		for(j=0;j<8;j++) 
	 	 {
			 
			b = bitmap[n];
			a = b | 0x80;
			Write_0108_Data(a);					
			n++;
	 	 }
	 }
	else 
	 {
		for(j=0;j<8;j++) 
	 	 {
			Write_0108_Data(bitmap[n]);
			n++;
	 	 }		 
	 }
	 
}


/********************************************************************************************************

void Set_Caracter(unsigned char cs, unsigned char page, unsigned char num, unsigned char far * bitmap)

ʾʾһ

cs: ҪַҺCS1, CS2  CS3;

page: Ҫַʼҳ

num: ַǰĿոλΪ

bitmapݱַ

********************************************************************************************************/

void Set_Caracter(unsigned char cs, unsigned char page, unsigned char num, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);
	
	Write_0108_Reg(Set_Page + page);				/* ʼҳ */
	Write_0108_Reg(Set_Column + num * 8);			/* ʼ */
	Write_0108_Reg(Set_Start_Line_0);				/* ʼ */

	for(j=0;j<16;j++) 
	 {
		Write_0108_Data(bitmap[n]);
		n++;
	 }
	
	page += 1;
	
	Write_0108_Reg(Set_Page + page);				/* ڶҳ */
	Write_0108_Reg(Set_Column + num * 8);
	
	for(j=0;j<16;j++) 
	 {
		Write_0108_Data(bitmap[n]);
		n++;
	 }
	 
}

/****************************************************************

ҳͬʱʾһʾҳ

cs: ҪַҺCS1, CS2  CS3;

page: Ҫַʼҳ

bitmapݱַ
  
****************************************************************/

void Set_Two_Page(unsigned char cs, unsigned char page, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);

	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Start_Line_0);

	for(j=0;j<64;j++) 
	{
		if (j<63)
		Write_0108_Data(bitmap[n]);
		else 
		Write_0108_Data(~bitmap[n]);		/* ҪʾΪ63ʱҪ˵߿ */
		
		n++;
	}
	
	page += 1;
	
	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	
	for(j=0;j<64;j++) 
	 {
		if (j<63)
		Write_0108_Data(bitmap[n]);
		else 
		Write_0108_Data(~bitmap[n]);		/* ҪʾΪ63ʱҪ˵߿ */		
		
		n++;
	 }
	 
}

/****************************************************************

ҳ˸ʾһʾհҳ

cs: ҪַҺCS1, CS2  CS3;

page: Ҫַʼҳ

bitmapݱַ

****************************************************************/

void FSH_Set_Two_Page(unsigned char cs, unsigned char page, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);

	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Start_Line_0);

	for(j=0;j<64;j++) 
	{
		if (j<63)
		Write_0108_Data(bitmap[n]);
		else 
		Write_0108_Data(bitmap[n]);
		
		n++;
	}
	
	page += 1;
	
	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	
	for(j=0;j<64;j++) 
	 {
		if (j<63)
		Write_0108_Data(bitmap[n]);
		else 
		Write_0108_Data(bitmap[n]);		
		
		n++;
	 }
	 
}
/****************************************************************

ҳʾһνʾҳзʾ

cs: ҪַҺCS1, CS2  CS3;

page: Ҫַʼҳ

bitmapݱַ

****************************************************************/

void Comp_Set_Two_Page(unsigned char cs, unsigned char page, unsigned char far * bitmap)
{
	unsigned char j;
	
	unsigned char a,b;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);

	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	Write_0108_Reg(Set_Start_Line_0);

	if (page == 2)
	 {
		for(j=0;j<64;j++) 
		 {				 
			if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
			Write_0108_Data(bitmap[n]);
 
			else
			 {
				b = bitmap[n];
				a = b & 0xfe;
				Write_0108_Data(~a);						/* ʾ */				
			 }
			n++;				 
		 }
	 }	
	else if (page != 2)
	 {				 
		for(j=0;j<64;j++) 
		 {
			if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
			Write_0108_Data(bitmap[n]);
 
			else
			Write_0108_Data(~bitmap[n]);					/* ʾ */			 
			n++;
		 }	
	 }
	
	page += 1;
	
	Write_0108_Reg(Set_Page + page);
	Write_0108_Reg(Set_Column);
	
	if (page == 7)
	 {
		for(j=0;j<64;j++) 
		 {				 
			if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
			Write_0108_Data(bitmap[n]);
 
			else
			 {
				b = bitmap[n];
				a = b & 0x7f;
				Write_0108_Data(~a);						/* ʾ */
			 }
			n++;					 
		 }
	 }		
	else if (page != 7)
	 {				 
		for(j=0;j<64;j++) 
		 {
			if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
			Write_0108_Data(bitmap[n]);
 
			else
			Write_0108_Data(~bitmap[n]);					/* ʾ */	 
			n++;
		 }	
	 }
}

/****************************************************************

ʾһʾʾCS1, CS2  CS3

cs: ҪַҺCS1, CS2  CS3;

bitmapݱַ

****************************************************************/

void Set_Screen(unsigned char cs, unsigned char far *bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		Write_0108_Reg(Set_Start_Line_0);
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(bitmap[n]);
			n++;
//			if (n == 64*(k*3+1))
//			n = 64*(3*k+3);
		}
		
	}
}

/****************************************************************

ʾĻзʾCS1, CS2  CS3

cs: ҪַҺCS1, CS2  CS3;

x1: ʾʼҳ

y1: ʾĽҳ

bitmapݱַ

****************************************************************/

void Comp_Set_Screen(unsigned char cs, unsigned char x1, unsigned char y1, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	unsigned char a;
	unsigned char b;
	unsigned char c;
	unsigned char d;
	
	
//	a = bitmap[0];
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		Write_0108_Reg(Set_Start_Line_0);
		
		if ((k < x1)||(k > y1))
		 {
			for(j=0;j<64;j++) 
		 	{
				Write_0108_Data(bitmap[n]);
				n++;
		 	}
		 }
		if ((k >= x1)&&(k <= y1))				/* ʾ */
		 {
			if (k==2)
			 {
				for(j=0;j<64;j++) 
		 	  	{				 
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					 {
						b = bitmap[n];
						a = b & 0xfe;
						Write_0108_Data(~a);						/* ʾ */			
					 }
					n++;				 
				}
			 }	
			 
			if (k==7)
			 {
				for(j=0;j<64;j++) 
		 	  	{				 
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					 {
						b = bitmap[n];
						a = b & 0x7f;
						Write_0108_Data(~a);						/* ʾ */	
					 }
					n++;					 
				}
			 }			 
			
			else if ((k!=2)&&(k!=7))
			 {				 
				for(j=0;j<64;j++) 
		 	  	 {
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					Write_0108_Data(~bitmap[n]);					/* ʾ */	
								 
					n++;
		 	  	 }	
			 }
		 }
	}
}

/****************************************************************

ָ˸ʾ򣺶ֵ˸ʾ

cs: ҪַҺCS1, CS2  CS3;

x2: ʾʼҳ

y2: ʾĽҳ

bitmapݱַ

****************************************************************/

void Flash_Set_Screen(unsigned char cs, unsigned char x2, unsigned char y2, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		Write_0108_Reg(Set_Start_Line_0);
		
		if ((k < x2)||(k > y2))
		 {
			for(j=0;j<64;j++) 
		 	{
				Write_0108_Data(bitmap[n]);
				n++;
		 	}
		 }
		 
		if ((k >= x2)&&(k <= y2))				/* ʾհ */
		 {
			if (k==2)
			 {
				for(j=0;j<64;j++) 
		 	  	{				 
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					 {
						Write_0108_Data(0x01);						/* ʾհ */		
					 }
					n++;				 
				}
			 }	
			 
			if (k==7)
			 {
				for(j=0;j<64;j++) 
		 	  	{				 
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					 {
						Write_0108_Data(0x80);						/* ʾհ */	
					 }
					n++;					 
				}
			 }			 
			
			else if ((k!=2)&&(k!=7))
			 {				 
				for(j=0;j<64;j++) 
		 	  	 {
					if((j == 0)||((j == 63)&&(cs == CS3)))			/* ˵߿ */
					Write_0108_Data(bitmap[n]);
 
					else
					Write_0108_Data(0x00);							/* ʾհ */	
								 
					n++;
		 	  	 }	
			 }
		 }		 
	}
}

/****************************************************************

лָʾݳлָʾ

cs: ҪַҺCS1, CS2  CS3;

x3: ʾʼҳ

y3: ʾĽҳ

bitmapԭݱַ

new_bitmapµݵַ

****************************************************************/

void Change_Set_Screen(unsigned char cs, unsigned char x3, unsigned char y3, unsigned char far * new_bitmap, unsigned char far * bitmap)
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	if (cs == CS1)
	 {
		CSA=0;
		CSB=0;
	 }
	else if (cs == CS2)
	 {
		CSA=0;
		CSB=1;
	 }
	else if (cs == CS3)
	 {
		CSA=1;
		CSB=0;
	 }
	 
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		Write_0108_Reg(Set_Start_Line_0);
		
		if ((k < x3)||(k > y3))						/* ճʾԪ˵ */
		 {
			for(j=0;j<64;j++) 
		 	{
				Write_0108_Data(bitmap[n]);
				n++;
		 	}
		 }
		if ((k >= x3)&&(k <= y3))					/* л */
		 {
			for(j=0;j<64;j++) 
		 	{
//				if((j == 0)||(j == 0))
//				Write_0108_Data(bitmap[n]);
				
//				else
				Write_0108_Data(new_bitmap[n-x3*64]);
				
				n++;
		 	}	
		 }
	}
}

/****************************************************************
  KS0108ʾ洢
****************************************************************/

/*
void Set_Screen3()
{
	unsigned char j, k;
	unsigned int n=0;
	unsigned int i;
	
	CSA=0;
	CSB=0;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		
	Write_0108_Reg(Set_Start_Line_0);

//		i = 64*(k*3+1);
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(nBitmapDot16_1[n]);
			n++;
//			if (n == 64*(k*3+1))
//			n = 64*(3*k+3);
		}
		
	}
}
void Set_Screen4()
{
	unsigned char j, k;
	unsigned int n=0;
//	unsigned int n=64;

	CSA=0;
	CSB=1;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		
	Write_0108_Reg(Set_Start_Line_0);
		
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(nBitmapDot16_2[n]);
			n++;
//			if (n == 64*(k*3+2))
//			n = 64*(3*k+4);
		}
		
	}
}
void Set_Screen5()
{
	unsigned char j, k;
	unsigned int n=0;
//	unsigned int n=128;

	CSA=1;
	CSB=0;
	Delay(100);
	for(k=0;k<8;k++)
	{
		Write_0108_Reg(Set_Page+k);
		Write_0108_Reg(Set_Column);
		
	Write_0108_Reg(Set_Start_Line_0);
		for(j=0;j<64;j++) 
		{
			Write_0108_Data(nBitmapDot16_3[n]);
			n++;
//			if (n == 64*(k*3+3))
//			n = 64*(3*k+5);
		}
		
	}
}

*/

//////////////////////////////////////////////////////////////////////////////////


