typedef		unsigned char uchar;
typedef		unsigned int uint;

#define Bit(x)		     (1<<(x))
#define bitset(var, bitno)   ((var) |=  (1 << (bitno)))
#define bitclr(var, bitno)   ((var) &= ~(1 << (bitno)))

struct	ubit_def 
{
	uchar	b0:1;
	uchar	b1:1;
	uchar	b2:1;
	uchar	b3:1;
	uchar	b4:1;
	uchar	b5:1;
	uchar	b6:1;
	uchar	b7:1;
};
union	ubyte_def
{
	struct	ubit_def bit;
	uchar	byte;
};

//*********************************************
//key status flag
uint	btcurkeyFlag;
uint	btkeyFlagP;
uint	btprekeyFlag;
uint	btkeyFlag;		//key status available

#define b_k_program		8	//Դ
#define b_k_power		7	//Դ
#define b_k_start		6	//
#define b_k_water		5	//ˮλ
#define b_k_function	4	//
#define b_k_back		3	//
#define b_k_confirm		2	//ȷ
#define b_k_add			1	//+
#define b_k_subtra		0	//-

uchar	btcounter_Key;
uchar	btkeyturn;
//*********************************************
union	ubyte_def btFlag1;
#define b_power		btFlag1.bit.b7       //Դ
#define b_start		btFlag1.bit.b6       //
#define b_book 		btFlag1.bit.b5       //ԤԼ
#define b_add 		btFlag1.bit.b4       //+ key
#define b_subtra 	btFlag1.bit.b3       //- key
#define b_confirm 	btFlag1.bit.b2       // confirm key
#define b_back 		btFlag1.bit.b1       // back key
//#define bit0 		btFlag1.bit.b0       //

union	ubyte_def btFlag2;
#define b_powder	btFlag2.bit.b7       //ϴ·
#define b_xiaodu	btFlag2.bit.b6       //

union	ubyte_def btFlag9;
#define b_buzz    btFlag9.bit.b7       //

//**************************************************
uchar	btmenu;
	// 0˵1˵2˵; 3˵
uchar 	btprogramturn;
	/*
	0  1ǿ 2
	3ٳ  4׼ 5ͯ 
	6        7˿ë֯Ʒ8ϴ
	9Ưϴ    10ѳ 11
	12 ˵
	*/
uchar	btfunction;
	/*
	0,ˮλ 1ʱ䣻 2ϴʱ䣻 3Ưϴ 
	4,ˮʱ䣻 5,ԤԼʱ䣻  
	*/
uchar	btsetting;
	/*
	0ϴ·
	1ϴ·
	2ϴ·
	3ϴ·
	*/
uchar 	btwaterlevel;	
	//ˮλ

uchar	btbooktime;	
	//ԤԼʱ

uchar 	btdiptime;	
	//ʱ

uchar 	btwashtime;	
	//ϴʱ

uchar	btfloatturn;	
	//Ưϴ

uchar	btdrytime;	
	//ˮʱ

uchar	btwaterhold;
	//ˮѡ

uchar 	btwashturntime;
	//ϴ¹ѭʱ
	
uchar	btstep;
	//ϴ³
union	ubyte_def trcmd;
#define b_cw		trcmd.bit.b7       //
#define b_ccw		trcmd.bit.b6       //

//*************************************************
uchar	btbuzzcode;
/*
 A0: 
 E0:ԤԼǱ
 E1:ˮ쳣
 E2:쳣
 E3:ˮ쳣
 E4:ˮ쳣
 E5:ˮλ쳣
 E6:ˮλ쳣
 F4:ͨѶ쳣
 EA:ˮ
*/
//***************************************************
uchar	bt1sflag;
#define b_1stm7      7       //
#define bit6      6       //
#define bit5      5       //
#define bit4      4       //
#define bit3      3       //
#define bit2      2       //
#define bit1      1       //
#define bit0      0       //
uchar	bt10msflag;
#define b_10mstm7      7       //
#define bit6      6       //
#define bit5      5       //
#define bit4      4       //
#define bit3      3       //
#define bit2      2       //
#define bit1      1       //
#define bit0      0       //
//***************************************************
#define dot       7       //
#define bit7      7       //
#define bit6      6       //
#define bit5      5       //
#define bit4      4       //
#define bit3      3       //
#define bit2      2       //
#define bit1      1       //
#define bit0      0       //
//****************************************************

#define ON		1
#define OFF		0
#define S_ON		0
#define S_OFF		1

//*****************************************************
//timer based on 10ms
#define _2s	200
#define _1s8	180
#define _1s6	160
#define _1s5	150
#define _1s4	140
#define _1s3	130
#define _1s2	120
#define _1s1	110
#define _1s	100
#define _0s9	90
#define _0s8	80
#define _0s7	70
#define _0s6	60
#define _0s5	50
#define _0s4	40
#define _0s3	30
#define _0s2	20
#define _0s1	10
//******************************************************
