/**************************************************************
* *
* File Name : Iic_bus.h *
* Contents : IIC Bus Definition file *
* Copyright : RENESAS TECHNOLOGY CORPORATION *
* AND RENESAS SOLUTIONS CORPORATION *
* Version : 1.0 *
* note : *
* *
**************************************************************/

#define ACK 0				/* Ӧλ */
#define NOACK 1				/* Ӧλ */
#define WRITE_MODE 0		/* д */
#define READ_MODE 1			/*  */

typedef unsigned char uchar;

/* EEPROM дЭṹ */
typedef struct {            
	
	unsigned char iic_DeviceAddress;
	unsigned char iic_MemoryAddress;
	unsigned char *iic_Data;
	unsigned char iic_NumberOfByte;

}IicPack;

void initIicBus(void);							/* I2C ߳ʼ */

unsigned char IicBusRead(IicPack *);			/* I2C д */
unsigned char IicBusWrite(IicPack *);			/* I2C ߶ */

void StartCondition(void);			/* I2C ʼ״̬ */
void StopCondition(void);			/* I2C ״̬ */

unsigned char ByteWrite(unsigned char);					/* I2C дֽ */
void ByteRead (unsigned char *, unsigned char);			/* I2C ֽ */