#ifndef MAIN_H
#define MAIN_H

extern	void wash_init(void);				/* ʼ */
extern	void init(void);					/* ʼ */
extern	void key(void);						/*  */
extern	void buzz(void);					/*  */
extern	void buzz_power(void);				/* Դ */
extern	void demo_judge(void);				/* ʾжϴ */

extern	void alarm(void);					/*  */
extern	void save_water(void);				/* ˮ */

extern	void led(void);						/* LEDʾ */

extern	void inertial(void);				/* ˮ */

extern	void key_led(void);					/*  LED  */
//extern	void key_logic(void);
extern	void key_power(void);				/* Դ */
extern	void key_start(void);				/* ʼ */
extern	void key_program(void);				/*  */
extern	void key_function(void);			/* ܼ */
extern	void key_pro_fun(void);				/* ܼ */
extern	void key_process(void);				/* ̼ */
extern	void key_water(void);				/* ˮλ */
extern	void key_preset(void);				/* ԤԼ */
extern	void key_preset_normal(void);		/* ܼ */
extern	void key_preset_cont(void);			/* ܼ */		

extern	void logic(void);					/* ϴ¹߼ */
extern	void operation(void);				/* ߼ */
extern	void status(void);					/* ϴ»״̬жϴ */

extern	void inlet(unsigned char, unsigned char, unsigned char);		/* ˮ̴ */

extern	void soak(unsigned int);			/* ݹ̴ */
extern	void wash(unsigned int);			/* ϴӹ̴ */
extern	void drain(void); 					/* ˮ̴ */
extern	void interm_spin(unsigned int);		/* ˮ̴ */		
extern	void spin(unsigned int);			/* ˮ̴ */		
extern	void run_stream(void);				/* ˮжϴ */		
extern	void stream_moto(unsigned int, unsigned int);		/* ת */		

extern	void weight_test(void);				/* Դ */		
extern	void texture_test(void);			/* ֪Դ */		

extern	void test_no_water(void);			/* ˮԴ */
extern	void test_production(void);			/* Դ */
extern	void test_cycle(void);				/* ѭϻԴ */
extern	void test_interm_spin(void);		/* ˮԴ */	
extern	void test_weight(void);				/* Դ */
/*
extern	void cotton_program(void);
extern	void tubedry_program(void);
extern	void fiber_program(void);
extern	void standard_program(void);
extern	void jeans_program(void);
extern	void fastest_program(void);
extern	void speedy_program(void);
extern	void common_program(void);
*/
//------------------------------------------------------------------------

extern	void memo_program(void);			/* д */		 
extern	void strong_program(void);			/* ǿд */
extern	void soft_wash_program(void);		/* д */
extern	void speedy_program(void);			/* ٳд */
extern	void standard_program(void);		/* ׼д */	  
extern	void child_program(void);			/* ͯд */
extern	void wool_program(void);			/* ë֯Ʒд */
extern	void silk_program(void);			/* ˿֯Ʒд */
extern	void single_wash_program(void);		/* ϴд */
extern	void rinse_program(void);			/* Ưϴд */		 
extern	void single_spin_program(void);		/* д */
extern	void tubedry_program(void);			/* Ͱд */

//------------------------------------------------------------------------

extern	void	key_buzz(void); 			/*  */   
extern	void	eoc_buzz(void); 			/*  */                 
extern	void	err_buzz(void); 			/*  */            
extern	void	buzz_on(unsigned char); 	/* ʼ */         
extern	void	buzz_st(void); 				/*  */     

extern	void    enable(void); 				/* ----  */                      
extern	void    disable(void); 				/* ----  */   	    

//------------------------------------------------------------------------

extern	void input(void); 					/* ⲿ봦 */   
extern	void output(void); 					/*  */

/* ʣʱ䴦 */
extern	unsigned char program_time(unsigned char far * table_adr, unsigned char table_colum);


extern	void	eeprom_read(void); 			/* EEPROM  */
extern	void 	eeprom_write(void); 		/* EEPROM д */

extern	void	i2c_write(unsigned char,unsigned char); 		/* I2C д */
extern	void	i2c_send8bit(unsigned char); 					/* I2C ߷8λݴ */

extern	void	i2c_start(void); 					/* I2C ߿ʼ״̬ */
extern	void	i2c_stop(void); 					/* I2C ߽״̬ */
  
extern	unsigned char	i2c_ack(void); 					/* I2C Ӧ */
extern	unsigned char	i2c_read(unsigned char); 		/* I2C ߶ */
extern	unsigned char	i2c_receive8bit(void); 			/* I2C ߽8λݴ */
    
extern	unsigned char dd;

extern  void _WaitTime0us(void); 			/* I2C ߵȴ 0 */
extern  void _WaitTime1us(void); 			/* I2C ߵȴ 1 */
extern  void _WaitTime2us(void); 			/* I2C ߵȴ 2 */

/* ======================== led #define ============================ */

/*
#pragma	ADDRESS			RAM_TOP			0x00400
#pragma	ADDRESS			RAM_BOTTON		0x00800

#pragma	ADDRESS			RAM_TOP			0x00A00
#pragma	ADDRESS			RAM_BOTTON		0x00E00
*/


#define			RAM_TOP			(unsigned char *)0x00400
#define			RAM_BOTTON		(unsigned char *)0x004F5

#define			RAM_TOP_1			(unsigned char *)0x00900
#define			RAM_BOTTON_1		(unsigned char *)0x00a00

#define			RAM_TOP_2			(unsigned char *)0x00aa5
#define			RAM_BOTTON_2		(unsigned char *)0x00b98

#define			Rec_Byte			(*(unsigned char *)0x00906)


#define		STAND_BY		0x00				/* ϴ»ڵȴ״̬ */
#define		INITIAL			0x01				/* ϴ»趨״̬ */
#define		RUN				0x02				/* ϴ»״̬ */
#define		STOP			0x03				/* ϴ»ֹͣ״̬ */
#define		TEST			0x04				/* ϴ»ڲ״̬ */
#define		PRESET			0x05				/* ϴ»ԤԼ״̬ */

//#define		WEIGHT_TEST		0x06
//#define		WATER_TEST		0x07

#define		WEIGHT_1		0x01				/*  1 */
#define		WEIGHT_2		0x02				/*  2 */
#define		WEIGHT_3		0x03				/*  3 */
#define		WEIGHT_4		0x04				/*  4 */

#define		SOFT_TXT		0x00				/*  */
#define		COMMON_TXT		0x01				/* ͨ */
#define		HARD_TXT		0x02				/* Ӳ */

#define		W_LOW			0x00				/* ˮλ */
#define		W_MIDDLE		0x01				/* ˮλ */
#define		W_HIGH			0x02				/* ˮλ */

#define		TEST_WASH_TIME	20

#define		C1				0x00		
#define		C2				0x01
#define		C3				0x02

#define		TEST1			0x10
#define		TEST2			0x11
#define		TEST3			0x12
#define		TEST4			0x13
#define		TEST5			0x14

#define		KEY1_6			0x12				/* ˫ */
#define		KEY2_3			0x0a				/* ˫ */
#define		KEY2_5			0x0c				/* ˫ */
#define		KEY3_4			0x21				/* ˫ */
#define		KEY4_5			0x28				/* ˫ */
#define		KEY2_3_6		0x07				/*  */
#define		KEY2_5_6		0x0e				/*  */
#define		KEY3_4_6		0x23				/*  */
#define		KEY4_5_6		0x2a				/*  */

#define		EXT_WASH		0x01
#define		EXT_RINSE		0x02
#define		EXT_SPIN		0x04
#define		SOFT_SPIN		0x08
#define		EXT_W_R			0x03
#define		EXT_W_S			0x05
#define		EXT_W_SS		0x09
#define		EXT_R_S			0x06
#define		EXT_R_SS		0x0a
#define		EXT_W_R_S		0x07
#define		EXT_W_R_SS		0x0b

/* ======================== operation #define ============================ */

 #define	Memo_PGM			0x00				/* жֽ */
 #define	Strong_PGM			0x01				/* ǿжֽ */
 #define	Soft_PGM			0x02				/* жֽ */
 #define	Quick_PGM			0x03				/* ٳжֽ */
 #define	Standard_PGM		0x04 				/* ׼жֽ */ 
 #define	Child_PGM			0x05				/* ͯжֽ */
 #define	Wool_PGM			0x06				/* ë֯Ʒжֽ */
 #define	Silk_PGM			0x07				/* ˿֯Ʒжֽ */  
 
 #define	Wash_PGM			0x8				/* ϴжֽ */ 
 #define	Rinse_PGM			0x9				/* Ưϴжֽ */ 
 #define	Spin_PGM			0xa				/* ˮжֽ */ 
 #define	Special_PGM			0xb				/* жֽ */ 

//---------------------------------------------------------------------------

#define		NORMAL					0xff
	
#define		INLET_SET_TIME			120				/* ˮĬʱ */ 
#define		SOFTENER_INLET			0x08
#define		SOFTENER_INLET_TIME		10				/* עʱ */ 
#define		INLET_ERR_TIME			1200			/* ˮʱʱ */


#define		CW						0x01			/* ת */
#define		DRAIN					0x02			/* ˮ */
#define		INLET					0x04			/* ˮ */
#define		SOFNER					0x08			/*  */
#define		CCW						0x10			/* ת */
#define		BREAK					0x20			/* ౣ */
#define		ACOFF					0x40			/* Զϵ */


#define		DRAIN_CONT_TIME			60			/* ˮλΪ 0 ˮʱ */
#define		DRAIN_ERR_TIME			480			/* ˮʱʱ */
#define		DRAIN_SET_TIME			120			/* ˮĬʱ */
#define		DRAIN_CONT_TIME_A		10			/* A ͻˮʱ */
#define		DRAIN_CONT_TIME_B		20			/* B ͻˮʱ */

//#define		SOAK_MOT_A				0xff
//#define		SOAK_MOT_B				0xff
//#define		SOAK_MOT_C				0xff

//#define		SOAK_10M				0xff
//#define		SOAK_20M				0xff
//#define		SOAK_30M				0xff

#define		MACHINE_A				0x00		  /* A ͻ */
#define		MACHINE_B				0x01		  /* B ͻ */

#define		PRESET_LID_ERR				0x01		  /* ԤԼǴ */
#define		DRAIN_ERR					0x02		  /* ˮʱ */
#define		OPEN_LID_ERR				0x03		  /* пʼǴ */
#define		SPIN_UNBALAN_ERR			0x04		  /* ˮײͰ */
#define		INLET_ERR					0x05		  /* ˮ */
#define		INLET_OVTIME_ERR			0x06		  /* ˮʱ */

#define		STREAM_RUN			0x81		  /* ˮ״̬ */
#define		STREAM_STOP			0x80		  /* ˮֹͣ״̬ */

#define		MAIN_STREAM			0x11		  /* ˮж */
#define		SOFT_STREAM			0x21		  /* ˮж */
#define		BALANCE_STREAM		0x31		  /* ƽˮж */
#define		EXT_STREAM			0x41		  /* ǿˮж */
#define		RESOLVE_STREAM		0x51		  /* ںˮж */

#define		MOT_STOP_1			0x07		  /* ֹͣ 1 */
#define		MOT_LEFT			0x03		  /* ת */
#define		MOT_RIGHT			0x0f		  /* ת */
#define		MOT_STOP_2			0x01		  /* ֹͣ 2 */

//#define		MOT_STILL				0x00
#define		MOT_STOP				0x00		  /* ֹͣ */
//#define		MOT_ON					0xff

#define		CW_OPT					p3_6		  /* ת˿ */
#define		Drain_OPT				p3_0		  /* ˮ˿ */		
#define		Inlet_OPT				p6_5		  /* ˮ˿ */		
#define		CCW_OPT					p4_5		  /* ת˿ */
#define		Break_OPT				p6_0		  /* Ԥ˿ */	
#define		SOF_Inlet_OPT			p8_0		  /* ע˿ */
#define		ACOFF_OPT				p8_1		  /* AC Դض˿ */
			
#define		CW_OPT_1				p8_2		  /* תʾ LED ˿ */		
#define		Drain_OPT_1				p8_3		  /* ˮʾ LED ˿ */	
#define		Inlet_OPT_1				p8_4		  /* ˮʾ LED ˿ */		
#define		CCW_OPT_1				p8_5		  /* תʾ LED ˿ */
#define		Break_OPT_1				p8_6		  /* Ԥ LED ˿ */
#define		SOF_Inlet_OPT_1			p1_4		  /* ʾ LED ˿ */
#define		ACOFF_OPT_1				p1_5		  /* AC Դضʾ LED ˿ */


//=======================================================================================

#define		BlackLight		p3_7		  /* ˿ */

#define		PRGM_Select		p3_5		  /* ѡ˿ */
#define		MKG_Switch		p3_3		  /* ſ˿ */
#define		ZHT_Switch		p3_4		  /* ײͰ˿ */
#define		BUZZ_Out		p3_1		  /* ˿ */

#define		AD_Result		ad0			  /* AD תĴ */
#define		V_REFF			vcut		  /* V_REFFԴƼĴ */
#define		AD_ST			adst		  /* AD תʼĴ */

#define		MKG_IPT					p3_3		/* ſ˿ */
#define		J1						p3_3		/* ſ˿ */
#define		ZHT_IPT					p3_4		/* ײͰ˿ */
#define		J2						p3_4		/* ײͰ˿ */
#define		MCHIN_TYPE				p3_5		/* ѡ˿ */
#define		J3						p3_5		/* ѡ˿ */

#define		BACK_LIT				p3_7

#define		AD_ZHD					p0_6		/* Ƕ˿ */
#define		AD_BACK					p0_7		/* Ԥ AD ˿ */

#define		LOAD_TEST				p1_6


#define		KEY_BUZ				6

//=======================================================================================

#define 	iic_sda_d			pd4_3		/* I2C ߶˿ */
#define 	iic_sda				p4_3
#define 	iic_scl_d			pd4_4
#define 	iic_scl				p4_4

#define 	_Wait_tHIGH			_WaitTime1us() 			/* Clock pulse width high */
#define 	_Wait_tLOW 			_WaitTime2us() 			/* Clock pulse width low */
#define 	_Wait_tHD_STA 		_WaitTime1us() 			/* Start hold time */
#define 	_Wait_tSU_STA 		_WaitTime1us() 			/* Start setup time */
#define 	_Wait_tHD_DAT 		_WaitTime0us() 			/* Data in hold time */
#define 	_Wait_tSU_DAT 		_WaitTime1us() 			/* Data in setup time */
#define 	_Wait_tAA 			_WaitTime1us() 			/* Access time */
#define 	_Wait_tSU_STO 		_WaitTime1us() 			/* Stop setup time */
#define 	_Wait_tBUF 			_WaitTime2us() 			/* Bus free time for next mode */

//=======================================================================================

/* ======================== led define ============================ */

#define		default_flag			operation_flag_1.f_bit.fb0		/* Ĭг־ */
#define		pro_default_flag		operation_flag_1.f_bit.fb1		/* Ĭг־ */
#define		cycle_start_flag		operation_flag_1.f_bit.fb2		/* תпʼ־ */
#define		stream_start_flag		operation_flag_1.f_bit.fb3		/* ˮпʼ־ */
#define		stream_stop_flag		operation_flag_1.f_bit.fb4		/* ˮֹͣ־ */
#define		run_demo_flag			operation_flag_1.f_bit.fb5		/* ʾб־ */
#define		start_demo_flag			operation_flag_1.f_bit.fb6		/* ʾʼ־ */

#define		flag_power				operation_flag_2.f_bit.fb0		/* Դ״̬־ */
#define		power_key_flag			operation_flag_2.f_bit.fb1		/* Դ±־ */
#define		run_water_key_flag		operation_flag_2.f_bit.fb2		/* ˮ־ */
#define		key_preset_flag			operation_flag_2.f_bit.fb3		/* ԤԼ־ */
#define		preset_confirm_flag		operation_flag_2.f_bit.fb4		/* ԤԼȷϱ־ */
#define		frequency_flag			operation_flag_2.f_bit.fb5		/* AC ԴƵʲԱ־ */
#define		balance_inlet_flag		operation_flag_2.f_bit.fb6		/* ƽˮ־ */
#define		balance_stream_flag		operation_flag_2.f_bit.fb7		/* ƽƽϴӱ־ */

#define		water_set_change_flag		operation_flag_3.f_bit.fb0		/* ˮλ趨ı־ */
#define		program_set_change_flag		operation_flag_3.f_bit.fb1		/* 趨ı־ */
#define		key2_switch_flag			operation_flag_3.f_bit.fb2		/* ʾб־ */
#define		recover_flag				operation_flag_3.f_bit.fb3		/* ־ */
#define		first_count_flag			operation_flag_3.f_bit.fb4		/* ˮһμ־ */
#define		first_init_flag				operation_flag_3.f_bit.fb5		/* ϵͳһγʼ״̬³ñ־ */
#define		balance_drain_flag			operation_flag_3.f_bit.fb6		/* ƽˮ־ */

#define		start_save_water_flag		save_water_flag_1.f_bit.fb0		/* ˮʼ־ */
#define		run_save_water_flag			save_water_flag_1.f_bit.fb1		/* ˮб־ */
#define		save_water_once_flag		save_water_flag_1.f_bit.fb2		/* ˮִб־ */
#define		release_save_water_flag		save_water_flag_1.f_bit.fb3		/* ˮͷű־ */
#define		lid_open_close_flag			save_water_flag_1.f_bit.fb4		/* ſһα־ */


#define		water_flash_flag		process_flag_1.f_bit.fb0	
#define		program_flash_flag		process_flag_1.f_bit.fb1	
#define		preset_flash_flag		process_flag_1.f_bit.fb2	
#define		soak_flash_flag			process_flag_1.f_bit.fb3	
#define		wash_flash_flag			process_flag_1.f_bit.fb4	
#define		rinse_flash_flag		process_flag_1.f_bit.fb5	
#define		spin_flash_flag			process_flag_1.f_bit.fb6	
#define		pro_flash_flag			process_flag_1.f_bit.fb7	


#define		select_tube_flag			key_flag_2.f_bit.fb0		/* Ͱ﹦ѡ־ */
#define		select_fastest_flag			key_flag_2.f_bit.fb1		/* ؿѡ־ */
#define		select_soak_flag			key_flag_2.f_bit.fb2		/* ѡ־ */
#define		tube_dry_enable_flag		key_flag_2.f_bit.fb3		/* Ͱʹ־ */
#define		save_water_enable_flag		key_flag_2.f_bit.fb4		/* ˮͷű־ */


#define		run_inlet_flag		process_flag_2.f_bit.fb0		/* ˮб־ */	
#define		run_soak_flag		process_flag_2.f_bit.fb1		/* б־ */		
#define		run_wash_flag		process_flag_2.f_bit.fb2		/* ϴб־ */		
#define		run_rinse_flag		process_flag_2.f_bit.fb3		/* Ưϴб־ */		
#define		run_spin_flag		process_flag_2.f_bit.fb4		/* ˮб־ */		
#define		run_err_flag		process_flag_2.f_bit.fb5		/* б־ */		


#define		key_water_flag			operation_flag_4.f_bit.fb0		/* ˮλ־ */	
#define		program_auto_flag		operation_flag_4.f_bit.fb1		/* Զб־ */	
#define		weight_finish_flag		operation_flag_4.f_bit.fb2		/* ɱ־ */	
#define		texture_finish_flag		operation_flag_4.f_bit.fb3		/* ʲɱ־ */	


#define		water_full_flag			operation_flag_5.f_bit.fb0		/* ˮ־ */	
#define		softener_flag			operation_flag_5.f_bit.fb1		/* ˮ־ */	
#define		drain_empty_flag		operation_flag_5.f_bit.fb2		/* ˮձ־ */	
#define		unbalance_flag			operation_flag_5.f_bit.fb3		/* ƽ־ */	


#define		test1_flag				test1_key_flag.f_bit.fb0
#define		t1_2key_flag			test1_key_flag.f_bit.fb1
#define		t1_3key_flag			test1_key_flag.f_bit.fb2
#define		test_1_start_flag		test1_key_flag.f_bit.fb3
#define		t1_finish_flag			test1_key_flag.f_bit.fb4

#define		test2_flag				test2_key_flag.f_bit.fb0
#define		t2_2key_flag			test2_key_flag.f_bit.fb1
#define		t2_3key_flag			test2_key_flag.f_bit.fb2
#define		test2_spin_flag			test2_key_flag.f_bit.fb3

#define		test3_flag				test3_key_flag.f_bit.fb0
#define		t3_key_flag				test3_key_flag.f_bit.fb1

#define		test4_flag				test4_key_flag.f_bit.fb0
#define		t4_2key_flag			test4_key_flag.f_bit.fb1
#define		t4_3key_flag			test4_key_flag.f_bit.fb2

#define		test5_flag				test5_key_flag.f_bit.fb0
#define		t5_2key_flag			test5_key_flag.f_bit.fb1
#define		t5_3key_flag			test5_key_flag.f_bit.fb2


#define		test_start_flag				test1_flag_1.f_bit.fb0
#define		t_mode_switch_flag			test1_flag_1.f_bit.fb1
#define		test_inlet_flag				test1_flag_1.f_bit.fb2
#define		test_softner_flag			test1_flag_1.f_bit.fb3


#define		key_buzz_flag			buzz_flag_1.f_bit.fb0		/* ־ */	
#define		buzz_flag				buzz_flag_1.f_bit.fb1		/* ־ */	
#define		buzz_switch_flag		buzz_flag_1.f_bit.fb2		/* л־ */	


//==========================================================================


extern  unsigned char base_4ms_buff;				/* ϵͳ 4ms  */	
extern  unsigned char base_500ms_buff;				/* ϵͳ 500ms  */	
extern  unsigned char base_1s_buff;					/* ϵͳ 1s  */	
extern  unsigned char base_1m_buff;					/* ϵͳ 1m  */	
extern  unsigned char base_1h_buff;					/* ϵͳ 1  */	

extern  unsigned char sys_1s_buff;					/* ϵͳ 1s  */
extern  unsigned char sys_10s_buff;					/* ϵͳ 10s  */
extern  unsigned char sys_1m_buff;					/* ϵͳ 1m  */
extern  unsigned char sys_1h_buff;					/* ϵͳ 1h  */

extern	signed char status_5m_buff;					/* ״̬ 5m  */
extern	signed char save_water_4hour_buff;			/* ˮ 4h  */

extern	signed char key2_2s_buff;					/*  2s  */
extern	unsigned char save_water_number;			/* ˮ */
extern	unsigned char old_key;						/* ϴμֵ */
extern	unsigned char program_buff;					/* ѡ */
extern	unsigned char process_buff;					/* ѡ */
extern	unsigned char function_buff;				/* ѡ */
extern	unsigned char water_count;					/* ˮλ */
extern	unsigned char water_buff;					/* ˮλѡ */

extern	unsigned char weight_buff;					/* ֵ */
extern	unsigned char texture_buff;					/* ֵ */
extern	unsigned char water_level;					/* ˮλֵ */					

extern	unsigned char preset_1s5_buff;				/* ԤԼ 1.5s  */
extern	signed char preset_500ms_buff;				/* ԤԼ 500ms  */

extern	unsigned char preset_3s_buff;				/* ԤԼ 3s  */
extern	signed char key3_1s5_buff;					
extern	signed char preset_5s_buff;					/* ԤԼ 5s  */

/* ======================== operation define ============================ */

extern  unsigned char operation_buff;				/* б */
extern	signed char operation_counter;				/* м */
extern	unsigned char pass_time_counter;			/* ʱ */
extern	unsigned char table_rom_number;				/* ѡ */
extern	unsigned char dependant_wash_time;

extern	unsigned char test_1_mode;					
extern	unsigned char test_buff;

extern	signed char run_1s_buff;					/*  1s  */

extern	signed char t1_switch_3s_buff;
extern	unsigned char test_1_3s_buff;
extern	unsigned char buzz_buff;
extern	unsigned char t1_end_3s_buff;

extern	unsigned char stream_run;				/* ˮб */
extern	unsigned char stream_stop;				/* ˮֹͣ */

extern	unsigned char finish;					/* ɱ */
extern	unsigned char key_release;				/* ɿ */
extern	unsigned char test_2_3s_buff;
extern	unsigned char test_2_7s_buff;

extern	signed char check_2s_buff;				/* 趨 2s  */
extern	signed char kaiji_3s_buff;				/* logoʾ 3s  */

extern	signed char inlet_10s_buff;				/* ˮ 10s  */
extern	signed int inlet_20m_buff;				/* ˮ 20m  */
extern	signed char inlet_2m_buff;				/* ˮ 2m  */


extern	signed int drain_8m_buff;				/* ˮ 8m  */
extern	signed char drain_2m_buff;				/* ˮ 2m  */
extern	signed char drain_60s_buff;				/* ˮ 60s  */
extern	signed char drain_10s_buff;				/* ˮ 10s  */
extern	signed char drain_20s_buff;				/* ˮ 20s  */

extern	unsigned char main_soak_time;			/* ʱ */
extern	unsigned char main_wash_time;			/* ϴʱ */

extern	signed char soak_1m_buff;				/*  1m  */
extern	signed char soak_2m_buff;				/*  2m  */
extern	unsigned char soak_3m_buff;				/*  3m  */
extern	unsigned char soak_4m_buff;				/*  4m  */
extern	signed int soak_9m_buff;				/*  9m  */

extern	unsigned char soak_1_cycle_buff;				/*  1m  */
extern	unsigned char soak_2_cycle_buff;				/*  2m  */
extern	unsigned char soak_3_cycle_buff;				/*  3m  */

extern	unsigned int run_stream_time;				/* ˮʱ */
extern	unsigned char balance_time_buff;			/* ƽˮʱ */
extern	unsigned char wash_start_flag;				/* ϴӿʼ־ */
extern	unsigned char wash_finish_flag;				/* ϴӽ־ */

extern	unsigned char interm_spin_10s_buff;				/* ˮ 10s  */
extern	unsigned char interm_spin_5s_buff;				/* ˮ 5s  */
extern	unsigned char interm_spin_4s_buff;				/* ˮ 4s  */
extern	unsigned char interm_spin_3s_buff;				/* ˮ 3s  */

extern	unsigned char spin_balance_time_buff;			/* ƽ */

extern	signed char inertial_30s_buff;				/* ˮ 30s  */
extern	signed char break_5s_buff;					/* ɲ 5s  */

extern	unsigned char output_buff;				/* ݱ */
extern	unsigned char save_output_buff;			/* ͣ */
extern	unsigned char machine_type;				/* жϱ */
extern	unsigned char err_buff;					/* 洢 */

extern	signed int process_left_time;			/* ʣʱ */
extern	unsigned char total_run_time;			/* ʱ */
extern	unsigned char total_left_time;			/* ʣʱ */

extern	unsigned char water_level_buff;			/* ˮλ洢 */

extern	unsigned char status_buff;				/* ϴ»״̬ */
extern	unsigned char lid_open;					/* ſؼ */
extern	unsigned char save_lid_status;			/* ſ״̬ݴ */
extern	unsigned char manual_process_buff;		/* ˹趨̴洢 */

extern	unsigned char ac_frequency;				/* AC ԴƵʱ */
extern	signed char mesure_time_buff;			/* AC ԴƵʲʱ */
extern	unsigned char frequency_tmp;			/* AC ԴƵʱ */

extern	unsigned char stream_table_row;			/* ˮд洢 */
extern	unsigned char ext_stream_table_row;		/* ǿˮ */

extern	unsigned char main_stream_time;			/* עˮʱ */
extern	unsigned char ext_stream_time;			/* ǿˮʱ */

extern	unsigned char mot_cycle_buff;			/* ת洢 */
extern	unsigned char stream_buff;				/* ˮ洢 */
extern	signed char stream_100ms_buff;			/* ˮ 100ms  */
extern	signed char base_100ms_buff;			/* ϵͳ 100ms  */

extern	unsigned char program_left_time;		/* ʣʱ */

extern	signed char buzz_24ms_buff;				/*  24ms  */

extern	signed char buzz_15m_buff;				/*  15ms  */

extern	signed char buzz_500ms_buff;			/*  500ms  */
extern	signed char buzz_time;     				/* ʱ */   

extern	unsigned char unbalance_count;			/* ƽ */


/* ======================== led define ============================ */



extern union byte_def_1 {

	volatile unsigned char byte;

	struct{

	unsigned char b0:1;
	unsigned char b1:1;
	unsigned char b2:1;
	unsigned char b3:1;
	unsigned char b4:1;
	unsigned char b5:1;
	unsigned char b6:1;
	unsigned char b7:1;

	}bi;
};



extern struct{
	
	union byte_def_1 led_0;
	union byte_def_1 led_1;
	union byte_def_1 led_2;
	union byte_def_1 led_3;
	union byte_def_1 led_4;
	
}led_disp;

extern struct{
	
	union byte_def_1 key_flag;
	union byte_def_1 flash;
	union byte_def_1 flag_2;
	union byte_def_1 flag_3;
	union byte_def_1 flag_4;
	
}flag;



extern struct struct_table{
	
	unsigned int run;
	unsigned int stop;
	
};

extern const struct struct_table Stream_Table_A[18][3];				/* A ͻˮʱ */
extern const struct struct_table Stream_Table_B[12][3];				/* B ͻˮʱ */
extern const struct struct_table Stream_Table_Ext_A[4][2];			/* A ͻǿˮʱ */
extern const struct struct_table Stream_Table_Ext_B[4][2];			/* B ͻǿˮʱ */
extern const struct struct_table Stream_Table_TEST[3][2];			/* ˮʱ */

extern const struct struct_table Balance_Stream_A[2];				/* ƽˮʱ */
extern const struct struct_table Speedy_Stream_A[4];				/* ˮʱ */
extern const struct struct_table Fastest_Stream_A[2];				/* ؿˮʱ */

/* ======================== Const Data Define ============================ */

//extern const unsigned char Common_Time_Table[1][27];

extern const unsigned char Standard_Time_Table[21];				/* ׼ʱ */

extern const unsigned char Memo_Time_Table[25];					/* ʱ */

extern const unsigned char Strong_Time_Table[23];				/* ǿʱ */

extern const unsigned char Silk_Time_Table[21];					/* ˿֯Ʒʱ */

extern const unsigned char Soft_Time_Table[33];					/* ʱ */

extern const unsigned char Child_Time_Table[33];				/* ͯʱ */

extern const unsigned char Wool_Time_Table[25];					/* ë֯Ʒʱ */

extern const unsigned char Speedy_Time_Table[14];				/* ٳʱ */

extern const unsigned char Fastest_Time_Table[16];				/* ؿʱ */

extern const unsigned char TubeDry_Time_Table[7];				/* Ͱʱ */


extern const unsigned char Single_Wash_Time_Table[];			/* ϴʱ */

extern const unsigned char Rinse_Time_Table[];					/* Ưϴʱ */

extern const unsigned char Single_Spin_Time_Table[];			/* ѳʱ */


extern const unsigned char Woven_Time_Table[33];				/* ޳ʱ */

extern const unsigned char Maotan_Time_Table[33];				/* ë̺ʱ */

/*************************************************************************************/

//extern const unsigned char Common_Soak_Time_Table[3][3];

//extern const unsigned char Common_Wash_Time_Table[3][3];

extern const unsigned char Memo_Soak_Time_Table[3][3];				/* ʱ */

extern const unsigned char Memo_Wash_Time_Table[3][3];				/* ϴʱ */

extern const unsigned char Standard_Soak_Time_Table[3][3];			/* ׼ʱ */

extern const unsigned char Standard_Wash_Time_Table[3][3];			/* ׼ϴʱ */

extern const unsigned char Strong_Soak_Time_Table[3];				/* ǿʱ */

extern const unsigned char Strong_Wash_Time_Table[3];				/* ǿϴʱ */


extern const unsigned char Soft_Soak_Time;					/* ʱ */
extern const unsigned char Soft_Wash_Time;					/* ϴʱ */

extern const unsigned char Child_Soak_Time;					/* ͯʱ */
extern const unsigned char Child_Wash_Time;					/* ͯϴʱ */

extern const unsigned char Wool_Soak_Time;					/* ë֯Ʒʱ */

extern const unsigned char Wool_Wash_Time;					/* ë֯Ʒϴʱ */

extern const unsigned char Silk_Wash_Time;					/* ˿֯Ʒϴʱ */
extern const unsigned char Speedy_Wash_Time;				/* ٳϴʱ */

extern const unsigned char seg_led_table[];					/* LED  */

extern const unsigned char OPT_Table[];						/* AC  */

extern const unsigned char Left_time_Colum_Table[];			/* ʱ洢 */


#endif