
#include "sfr_r82b.h"
#include "disp_definel.h"
#include "main_define.h"
#include "Iic.h"


//#pragma SECTION program pro_4

/******************************************************************************************

******************************************************************************************/

void water_detect(void);				/* Debugging Mode ˮλ⣬J1 ״̬Ϊ"ON"ʱʾˮλ趨ˮλ */
void wash_detect(void);					/* Debugging Mode ϴʱ⣬J2 ״̬Ϊ"ON"ʱ޸ϴӺͽݵʱ */
void ac_freqcy_detect(void);			/* AC ԴƵʼ */
void lid_detect(void);					/* ſؼ */
void unbalance_detect(void);			/* ƽ */
                 
/******************************************************************************************

void alarm(void): ˮʹ󱨾򣬵ˮͷź

******************************************************************************************/

void alarm(void)
{
 if (err_buff)
  {
	  run_err_flag = 1;	  
	  	 	  
	  switch (err_buff)
	  {
		  case PRESET_LID_ERR:				/* ԤԼǴ */
		  
		  if (lid_open == 0)
		   {
			  lid_open_close_flag = 0;			   
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
			  
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;	
			  		  
			  buzz_flag = 0;
			  run_err_flag = 0;
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;	
	    	  run_page3_flag = 0;			  			  
		   }
		  break;
		  
		  
		  case DRAIN_ERR:					/* ˮ */
		  
		  if (lid_open_close_flag == 1)
		   {
			  lid_open_close_flag = 0;
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;			  
			  buzz_flag = 0;	
			  run_err_flag = 0;		
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;
	    	  run_page3_flag = 0;					  				  	  		  
		   }			  		  
		  break;
		  
		  
		  case OPEN_LID_ERR:				/* 쳣 */
		  
		  if (lid_open == 0)
		   {
			  lid_open_close_flag = 0;			   
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;			  
			  buzz_flag = 0;	
			  run_err_flag = 0;		
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;	
	    	  run_page3_flag = 0;					  			  	  		  
		   }		  		  
		  break;
		  
		  
		  case SPIN_UNBALAN_ERR:			/* ˮײͰ */
		  
		  if (lid_open_close_flag == 1)
		   {
			  lid_open_close_flag = 0;
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;			  
			  buzz_flag = 0;	
			  run_err_flag = 0;		
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;	
	    	  run_page3_flag = 0;					  			  	  		  
		   }			  		  
		  break;
		  
		  
		  case INLET_ERR:					/* ˮ쳣 */
		  
		  if (lid_open_close_flag == 1)
		   {
			  lid_open_close_flag = 0;
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;			  
			  buzz_flag = 0;	
			  run_err_flag = 0;	
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;	
	    	  run_page3_flag = 0;					  			  		  		  
		   }			  
		  break;
		  
		  
		  case INLET_OVTIME_ERR:			/* ˮʱ */
		  
		  if (lid_open_close_flag == 1)
		   {
			  lid_open_close_flag = 0;
		  	  err_buff = 0;		 
		  	  status_buff = RUN;
		  	  program_start_flag = 1;
		  	  program_pause_flag = 0;			  
			  buzz_flag = 0;	
			  run_err_flag = 0;			
			  
	    	  Pflash = 0;
	    	  Tflash = 0;						
	    	  Pflash_switch_flag = 0x00;	
	    	  run_page3_flag = 0;					  			    		  
		   }			  
		  break;		  		  		  		  		  
		  
	  };
	  
  }
 
 if (run_save_water_flag == 1)	
  {
	  status_buff = STOP;
	  buzz_flag = 1;				/* ÷־ */
  }
 if (run_err_flag == 1)
  {
	  status_buff = STOP;	  
	  buzz_flag = 1;				/* ÷־ */
  }

}

/****************************************************************

void input(void)ⲿ봦 
   
****************************************************************/

void input(void)
{
	water_detect();			/* ˮλ */
	wash_detect();			/* ϴʱ */
	ac_freqcy_detect();		/* AC ԴƵʼ */
	lid_detect();			/* ſؼ */
	unbalance_detect();		/* òƽ */
}

/****************************************************************

void output(void) 
   
****************************************************************/

void output(void)
{
	unsigned char i;
	unsigned char j;
	unsigned char k;
	
//  buzz();
	
  i = output_buff;
	
  if (i == 0)			/* 洢Ϊ0 AC ˿ */
   {
	   CW_OPT = 0; 
	   CW_OPT_1 =0;			  
			  
	   Drain_OPT = 0;
	   Drain_OPT_1 = 0;
			  
	   Inlet_OPT = 0;
	   Inlet_OPT_1 = 0;
			  
	   SOF_Inlet_OPT = 0;
	   SOF_Inlet_OPT_1 = 0;
			  
	   CCW_OPT = 0;
	   CCW_OPT_1 = 0;
			  
	   Break_OPT = 0;
	   Break_OPT_1 = 0;
			  
	   ACOFF_OPT = 0;
	   ACOFF_OPT_1 = 0;		 
   }
  else if (i != 0)
   {
	for (j = 0; j < 8; j++)
	 {
		 k = (OPT_Table[j] & i);
		 if (k)
		 continue;
		 
		 switch (OPT_Table[j])			/* 洢Ϊ0Ϊ0Ķ˿ */
		  {
			  case CW:
		 
			  CW_OPT = 0; 
			  CW_OPT_1 =0;			  
			  break;
			  
			  
			  case DRAIN:
			  
			  Drain_OPT = 0;
			  Drain_OPT_1 = 0;
			  break;
			  
			  
			  case INLET:
			  
			  Inlet_OPT = 0;
			  Inlet_OPT_1 = 0;
			  break;		
			  
			  
			  case SOFNER:
			  
			  SOF_Inlet_OPT = 0;
			  SOF_Inlet_OPT_1 = 0;
			  break;	
			  
			  case CCW:
			  
			  CCW_OPT = 0;
			  CCW_OPT_1 = 0;
			  break;
			  
			  case BREAK:
			  
			  Break_OPT = 0;
			  Break_OPT_1 = 0;
			  break;		
			  
			  
			  case ACOFF:
			  
			  ACOFF_OPT = 0;
			  ACOFF_OPT_1 = 0;
			  break;				  			  	  
		  }
	 }	   
	for (j = 0; j < 8; j++)
	 {
		 k = (OPT_Table[j] & i);
		 if (!k)
		 continue;
		 
		 switch (OPT_Table[j])			/* 洢Ϊ0Ϊ0Ķ˿ںλΪ0Ķ˿ */
		  {
			  case CW:
			  
			  CW_OPT = 1;
			  CW_OPT_1 = 1;	  
			  break;
			  
			  
			  case DRAIN:
			  
			  Drain_OPT = 1;
			  Drain_OPT_1 = 1;
			  break;
			  
			  
			  case INLET:
			  
			  Inlet_OPT = 1;
			  Inlet_OPT_1 = 1;
			  break;		
			  
			  
			  case SOFNER:
			  
			  SOF_Inlet_OPT = 1;
			  SOF_Inlet_OPT_1 = 1;
			  break;	
			  
			  case CCW:
			  
			  CCW_OPT = 1;
			  CCW_OPT_1 = 1;
			  break;
			  
			  case BREAK:
			  
			  Break_OPT = 1;
			  Break_OPT_1 = 1;
			  break;		
			  
			  
			  case ACOFF:
			  
			  ACOFF_OPT = 1;
			  ACOFF_OPT_1 = 1;
			  break;				  			  	  
		  }
	 }
   }
   
  return;
  
}

/*************************************************************************

void water_detect(void)J1жJ3=1ʱJ1Ϊˮλ 
											 
*************************************************************************/

void water_detect(void)
{
	unsigned char i;
	
	machine_type = J3;
	
	if (machine_type == 0)								/* ⵽J3Ϊ0 */
	 {
		 if ((output_buff & INLET) != 0);				/* ˮǷ */
		  {
			  if (inlet_2m_buff <= 30)					/* ˮ 90s ʱ޸ˮλݴΪﵽ趨ֵ */
			   {
				    water_buff = water_level_buff;
		 			water_full_flag = 1;
		 			drain_empty_flag = 0;				   
			   }
			  
		  }
		  
		 if ((output_buff & DRAIN) != 0);				/* ˮǷ */
		  {
			  if (drain_2m_buff <= 30)					/* ˮ 90s ʱ޸ˮλݴΪˮſ */
			   {
		 			water_buff = 0;
		 			water_full_flag = 0;				   
			   }
			  
		  }		  	
		    
		 return;							/*  */
		 
	 }
	
	i = J1;							/* ⵽J3Ϊ1J1жˮλǷ趨ˮλ */
	
	if (i != 0)								/* J1Ϊ1ˮλ״̬Ϊﵽ趨ˮλ */
	water_buff = water_level_buff;
	else if (i == 0)						/* J1Ϊ0ˮλ״̬Ϊˮſ */
	water_buff = 0;
	
	if (water_buff == water_level_buff)
	 {
		 water_full_flag = 1;				/* ˮλ־ */
		 drain_empty_flag = 0;
	 }
	else if ((water_buff < water_level_buff)||(water_buff == 0))
	water_full_flag = 0;					/* ˮλ־ */
	return;
}

/*********************************************************************************

void wash_detect(void)J2жJ3=1ʱJ2ϴʱ޸ж 
											 
*********************************************************************************/

void wash_detect(void)
{
	unsigned char j;
	
	machine_type = J3;
	
	if (machine_type == 0)				/* ⵽J3Ϊ0 */
	return;	
	
	j = J2;								/* ⵽J3Ϊ1J2 */
	
	if (j != 0)							/* ⵽J2Ϊ1޸Ľݣϴʱ */
	 {
		run_stream_time = 30;			
		
  		soak_1m_buff = 30;
  		soak_2m_buff = 30;
  		soak_3m_buff = 30;
  		soak_4m_buff = 30;
  		soak_9m_buff = 30;
		process_left_time = 30;
	 }
	
	return;
}

/*********************************************************************************

void lid_detect(void)J1жJ3=0ʱJ1Ϊſؼ 
											 
*********************************************************************************/

void lid_detect(void)
{
	unsigned char j;
		
	machine_type = J3;
	
	if (machine_type == 0)					/* ⵽J3Ϊ0 */
	 {
		 j = J1;							/* ⵽J2 */
		 
		 if (j != save_lid_status)
		  {			  
			  if (save_lid_status == 0)
			   {
				   if((run_err_flag == 1)||(run_save_water_flag == 1))
				   lid_open_close_flag = 1;
			   }	
			   		  
			  save_lid_status = j;		
			  	  			  
		  }		 
		  
		 if (j == 1)						/* J1 = 1, Ź */
		  {
			  lid_open = 0;
		  }
		  
		 if (j == 0)						/* J1 = 0, ſ */
		  {
			  lid_open = 1;
		  }		  
		  
	 }
	 
}

/*********************************************************************************

void unbalance_detect(void)J2жJ3=0ʱJ2Ϊƽ 
											 
*********************************************************************************/

void unbalance_detect(void)
{	
	unsigned char j;
			
	machine_type = J3;
	
	if (machine_type == 0)								/* ⵽J3Ϊ0 */
	 {
		 j = J2;										/* ⵽J2 */
		 
		 if (j == 0)
		  {
			 if ((program_buff == Special_PGM)&&(status_buff == RUN))
			 err_buff = SPIN_UNBALAN_ERR;
			 
			 else 
			  {
				  if (((output_buff & CW) != 0)||((output_buff & CCW) != 0))
			 	  unbalance_count ++;	
					
			 	  if (unbalance_count == 3)
			 	  {
			 		  unbalance_count = 0;
			 		  unbalance_flag = 1;
					  err_buff = SPIN_UNBALAN_ERR;
			 	  }		

			  }

		  }
	 }
}

/*********************************************************************************

void ac_freqcy_detect(void)ACԴƵʼ⣬ͨINT2ȷƵֵ
											 
*********************************************************************************/

void ac_freqcy_detect(void)
{
	
	if ((ac_frequency >= 49)&&(ac_frequency <= 51))
	ac_frequency = 50;
	
	else if ((ac_frequency >= 59)&&(ac_frequency <= 61))
	ac_frequency = 60;
	
}

/*********************************************************************************

void demo_judge(void)ͨJ3жǷdemo
											 
*********************************************************************************/

void demo_judge(void)
{
	machine_type = J3;	
	
	if (machine_type == 0)					/* demo򣬳ʼ 0 */
	 {
		run_demo_flag = 1;
		
		menu_level_buff = Menu_Level_4;
		
		program_buff = Memo_PGM;				

	 }
	 
	 else 
	 run_demo_flag = 0;

}

/***************************************************************************************

unsigned char program_time(unsigned char far * table_adr, unsigned char table_colum)

ѡҪʱʱ䣬ʣʱ䣻㷽Ϊݳʱ
ʱ䣬Ȼݲ͹ʣʱʱ䣬óʣʱ

***************************************************************************************/
unsigned char program_time(unsigned char far * table_adr, unsigned char table_colum)
{
	unsigned char i;
	
	unsigned int total_time = 0;
	unsigned char left_time = 0;
	unsigned int pass_time = 0;

	
    for (i = 0; i < table_colum; i++)
     {	 
		if ((i == 1)&&(program_buff != Special_PGM))						/* ʱ */
		{	
			total_time += main_soak_time * 60;
			
			if (i == operation_counter)
			pass_time = (total_time - process_left_time);
						
			continue;
		}
			 
		if ((i == 2)&&(program_buff != Special_PGM))						/* ϴʱ */
		{			
			total_time += main_wash_time * 60;
			
			if (i == operation_counter)
			pass_time = (total_time - process_left_time);
						
			continue;
		}
			 
		if ((i == (table_colum - 3))&&(program_buff != Special_PGM))		/* ˮʱ */
		{
			
			if (spin_time_buff == 6)			  
			total_time += table_adr[i] * 60;
			  
			if (spin_time_buff != 6)
			total_time += spin_time_buff * 60;				
									
			if (i == operation_counter)
			pass_time = (total_time - process_left_time);			
			
			continue;
		}
			 
		if (i == operation_counter)						/* ǰйʣʱ */
		 {								
			total_time += table_adr[i];		 
			
			if ((i==0)&&(first_count_flag == 1))
			 {
				 first_count_flag = 0;
				 process_left_time = 120;
				 
				 if (program_buff == Special_PGM)
				 process_left_time = 5;
				 
				 pass_time = (total_time - process_left_time);				 
				 continue;
			 }
			
			pass_time = (total_time - process_left_time);				/* ʱ */
			
			if (program_buff == Special_PGM)
			 {
				  pass_time = (total_time - process_left_time/60);			
				  if ((process_left_time % 60) > 30)
				  pass_time -= 1;
			 }
									
			continue;
		 }		
		 
		total_time += table_adr[i];						/* Ҫʱ */
			
//		if (i == (table_colum-1))
//		{
//			left_time = (total_time - pass_time)/60;	
//		}	 	
     }		
	 
	if (program_buff == Special_PGM) 
	 {
		left_time = total_time - pass_time;
		process_left_time = 300;
	 }
	
	else 
	 {
		left_time = (total_time - pass_time)/60;		/* ʣʱ */
	
		if ((left_time % 60) > 30)
		left_time += 1;									/* ʣʱ */
	 }
	
    return left_time;									/* ʣʱ */

}

/**************************************************************

void eeprom_write(void)

ϵͳʱ״̬浽 EEPROM д

**************************************************************/

void eeprom_write(void)
{
	static unsigned char i=0;
	static unsigned char j=0;	
	
	IicPack IicData_w;
	
	IicData_w.iic_DeviceAddress = 0xa0;				/*  EEPROM 豸ַ */
	IicData_w.iic_MemoryAddress = 0x00;				/*  EEPROM дʼַ */
//	IicData_w.iic_Data = WriteData;
	IicData_w.iic_Data = RAM_TOP_2;					/* ״̬ RAM ַ */
	IicData_w.iic_NumberOfByte = 8;					/* һζдֽ */
	
	for (j = 0; j <= 30; j++)						/* ѭд룬ݶپѭ */
	 {
		 if (j == 30)
		  {
			  IicData_w.iic_NumberOfByte = 5;
			  
			  initIicBus();
			  IicBusWrite(&IicData_w);			  
			  break;
		  }
		  
		 initIicBus();
		 
		 IicBusWrite(&IicData_w);
		 
		 asm("nop");
		 
		 IicData_w.iic_MemoryAddress += 8;		 
//		 IicData_w.iic_Data += 8;
		 
		 epprom_4ms_buff = 1;
		 
		 while (epprom_4ms_buff)
		 {
		 	asm("nop");
		 }		 
	 }	
	
	asm("nop");
	asm("nop");
	asm("nop");
	
}

/*******************************************************************

void eeprom_read(void)

ϵͳʱ״ָ̬R8C MCU RAMУʹϵͳʱ״̬

*******************************************************************/

void eeprom_read(void)
{
	static unsigned char i=0;
	static unsigned char j=0;	
	
	IicPack IicData_w;	
	IicPack IicData_r;
	
	IicData_r.iic_DeviceAddress = 0xa0;		/*  EEPROM 豸ַ */
	IicData_r.iic_MemoryAddress = 0x40;		/*  EEPROM дʼַ */
//	IicData_r.iic_Data = ReadData;
	IicData_r.iic_Data = RAM_TOP_1;			/* ״̬ RAM ַ */
	IicData_r.iic_NumberOfByte = 0x08;		/* һζдֽ */
	
	initIicBus();	
	
	IicBusRead(&IicData_r);			/* 籣ֽڣжǷе */
	
	asm("nop");
	asm("nop");
	asm("nop");
	
	if(Rec_Byte == 1)				/* 籣ֽЧе */
	 {
	 
		IicData_r.iic_DeviceAddress = 0xa0;
		IicData_r.iic_MemoryAddress = 0x00;		 
		IicData_r.iic_Data = RAM_TOP;
		IicData_r.iic_NumberOfByte = 0xF5;
	
		initIicBus();	
	
		IicBusRead(&IicData_r);		/* ʱϵͳд MCU RAM  */
	
		asm("nop");
		asm("nop");
		asm("nop");	
		asm("nop");
		asm("nop");
		asm("nop");			
		
		Rec_Byte = 0;				/* 籣ֽ */
		
		IicData_w.iic_DeviceAddress = 0xa0;
		IicData_w.iic_MemoryAddress = 0x40;
		IicData_w.iic_Data = RAM_TOP_1;	
		IicData_w.iic_NumberOfByte = 8;	
		
		initIicBus();
		IicBusWrite(&IicData_w);	/*  EEPROM Ӧַĵ籣ֽ0 */
		
		asm("nop");
		asm("nop");
		asm("nop");	
		asm("nop");
		asm("nop");
		asm("nop");		
		
		recover_flag = 1;			/* õ־ */					
	
	 }
	 
}

/********************************************************
Name : initIicBus
Parameters : None
Returns : None
Description : initialize I2C-BUS port
********************************************************/

void initIicBus(void)
{
	iic_sda_d = 0; 					/* SDA input ("H" state) */
	iic_scl_d = 0; 					/* SCL input ("H" state) */
}

//-----------------------------------------------------------------

/********************************************************
Name : IicBusRead
Parameters : structure IicPack pointer
Returns : Acknowledge
Description : Sequential Ramdom Read Cycle (I2C-BUS)
********************************************************/

unsigned char IicBusRead(IicPack *IicData)
{
	unsigned char i,ret;											/* Ramdom Read Cycle / Sequential Ramdom Read Cycle */
	
	IicData->iic_DeviceAddress &= 0xFE; 							/* WRITE Setting DeviceAddress */
	StartCondition(); 												/* Start Condition */
	
	while (1) 
	 {
		
		if ((ret=ByteWrite(IicData->iic_DeviceAddress)) == NOACK)	/* WRITE DeviceAddress */
		break; 		
																	/* NoAck Detect */
		if ((ret=ByteWrite(IicData->iic_MemoryAddress)) == NOACK)
																	/* WRITE MemoryAddress */
		break; 														/* NoAck Detect */

		IicData->iic_DeviceAddress |= 0x01; 						/* READ Setting DeviceAddress */
		StartCondition(); 											/* ReStart Condition */
		if ((ret=ByteWrite(IicData->iic_DeviceAddress)) == NOACK)
																	/* DeviceAddress WRITE */
		break; 	
																	/* NoAck Detect */
		for (i=1; i<IicData->iic_NumberOfByte; i++) 
		 { 															/* specified bytes as loop */
			ByteRead (IicData->iic_Data, ACK); 						/* Read data (Ack output) */
			IicData->iic_Data++; 									/* */
		 }
	 
		ByteRead (IicData->iic_Data, NOACK); 						/* Read data (NoAck output) */
		break;
	 }
	StopCondition(); 												/* Stop Condition */
	return(ret);
}

//-------------------------------------------------------------------------

/********************************************************
Name : IicBusWrite
Parameters : structure IicPack pointer
Returns : Acknowledge
Description : Byte Write or Page Write Cycle (I2C-BUS)
********************************************************/
unsigned char IicBusWrite(IicPack *IicData)
{
	unsigned char i,ret;
																	/* Byte Write / Page Write */
	IicData->iic_DeviceAddress &= 0xFE; 							/* WRITE Setting DeviceAddress */
	StartCondition(); 												/* Start Condition */
	while (1) 
	 {
		if ((ret=ByteWrite(IicData->iic_DeviceAddress)) == NOACK)
																	/* WRITE DeviceAddress */
		break; 														/* NoAck Detect */
		if ((ret=ByteWrite(IicData->iic_MemoryAddress)) == NOACK)
																	/* WRITE MemoryAddress */
		break; 														/* NoAck Detect */
		for (i=0; i<IicData->iic_NumberOfByte; i++)					/* specified bytes as loop */
	 	 { 					
			if ((ret=ByteWrite(*(IicData->iic_Data))) == NOACK) 	/* Write Data */
			break; 													/* NoAck Detect */
			IicData->iic_Data++; 									/* */
	 	 }
		break;
	 }	
	
	StopCondition(); 												/* Stop Condition */
	return(ret);
	
}

//-------------------------------------------------------------------------

/********************************************************
Name : StartCondition
Parameters : None
Returns : None
Description : Output Start Condition (I2C-BUS)
Note : *1 adjust a wait time
********************************************************/
void StartCondition(void)
{
	iic_scl = 0; 						/* SCL="L" */
	iic_scl_d = 1; 						/* SCL output */
	_WaitTime1us(); 					/* wait *1 */
	iic_sda_d = 0; 						/* SDA="H" */
	_WaitTime1us(); 					/* wait */
	_WaitTime1us(); 					/* wait *! */
	iic_scl = 1; 						/* SCL="H" */
	_Wait_tSU_STA; 						/* wait */
	iic_sda = 0; 						/* SDA="L" */
	iic_sda_d = 1; 						/* SDA output */
	_Wait_tHD_STA; 						/* wait */
	_WaitTime1us(); 					/* wait *1 */
	iic_scl = 0; 						/* SCL="L" */
}
/********************************************************
Name : StopCondition
Parameters : None
Returns : None
Description : Output Stop Condition (I2C-BUS)
Note : *1 adjust a wait time
********************************************************/
void StopCondition(void)
{
	iic_scl = 0; 						/* SCL="L" */
	iic_scl_d = 1; 						/* SCL output */
	_WaitTime1us(); 					/* wait *1 */
	iic_sda = 0; 						/* SDA="L" */
	iic_sda_d = 1; 						/* SDA output */
	_WaitTime1us(); 					/* wait *1 */
	iic_scl = 1; 						/* SCL="H" */
	_Wait_tSU_STO; 						/* wait */
	iic_sda_d = 0; 						/* SDA="H" */
	_WaitTime1us(); 					/* wait */
	_WaitTime1us(); 					/* wait *1 */
	iic_scl = 0; 						/* SCL="L" */
}

//--------------------------------------------------------

/********************************************************
Name : ByteWrite
Parameters : Write data
Returns : Acknowledge
Description : byte data Output (I2C-BUS)
Note : *1 adjust a wait time
********************************************************/
unsigned char ByteWrite(unsigned char iic_writeData)
{
	unsigned char maskData = 0x80; 						/* MSB first */
	unsigned char ret = ACK; 								/* Ack/NoAck */
	
	while (maskData) 
	 { 									/* 8times as loop */
		iic_sda = 0; 										/* initialize port-latch */
		if (iic_writeData & maskData) 
		 { 								/* "H" output ? */
			iic_sda_d = 0; 										/* Yes SDA="H" */
		 }
		 
		else
		 {
			iic_sda_d = 1; 										/* No SDA="L" */
			asm("nop"); 										/* wait *1 */
			asm("nop"); 										/* wait *1 */
			asm("nop"); 										/* wait *1 */
		 }
		 
		_Wait_tSU_DAT; 										/* wait */
		_WaitTime1us(); 									/* wait *1 */
		iic_scl = 1; 										/* SCL="H" */
		_Wait_tHIGH; 										/* wait */
		_WaitTime1us(); 									/* wait *1 */
		iic_scl = 0; 										/* SCL="L" */
		maskData >>= 1; 									/* change mask data */
		_WaitTime1us(); 									/* wait *1 */
		
	 }
	 
		iic_sda_d = 0; 										/* SDA input */
		_Wait_tAA; 											/* wait */
		_WaitTime2us(); 									/* wait *1 */
		iic_scl = 1; 										/* SCL="H" */
		
		if (iic_sda) 
		ret=NOACK; 											/* NoAck Detect */
		
		_Wait_tHIGH; 										/* wait */
		
		_WaitTime1us(); 									/* wait *1 */
		iic_scl = 0; 										/* SCL="L" */
		_Wait_tHD_DAT; 										/* wait */
		
		return(ret);
		
}

//----------------------------------------------------------

/********************************************************
Name : ByteRead
Parameters : Read data strage location pointer, Select Ack/NoAck
Returns : None
Description : byte data input with Ack output (I2C-BUS)
Note : *1 adjust a wait time
********************************************************/
void ByteRead(unsigned char *iic_readData, unsigned char ackData)
{
	unsigned char maskData=0x80; 						/* MSB first */
	unsigned char readData;
	
	*iic_readData = 0; 									/* */
	
	while (maskData) 
	 { 													/* 8times as loop */
		readData = *iic_readData | maskData; 			/* */
		iic_sda_d = 0; 									/* initialize port-latch */
		_Wait_tAA; 										/* wait */
		iic_scl = 1; 									/* SCL="H" */
	
		if (iic_sda) 
	 	 { 												/* SDA="H" ? */
			*iic_readData = readData; 					/* Yes */
	 	 }
	
		else{
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		asm("nop"); 									/* wait *1 */
		}
		
		_Wait_tHIGH; 									/* wait */
		_WaitTime1us(); 								/* wait *1 */
		iic_scl = 0; 									/* SCL="L" */
		maskData >>= 1; 								/* Change mask data */
		_WaitTime1us(); 								/* wait *1 */
	 }
	 
	if (!ackData) 
	 { 													/* Ack output ? */
														/* Ack output */
		iic_sda = ACK; 									/* Yes SDA="L" */
		iic_sda_d = 1; 									/* SDA output */
	 } 
	 
	else
	 {
														/* NoAck output */
		iic_sda = NOACK; 								/* No SDA="H" */
		iic_sda_d = 0; 									/* SDA input */
   	}
	 
	_Wait_tSU_DAT; 										/* wait */
	_WaitTime1us(); 									/* wait *1 */
	iic_scl = 1; 										/* SCL="H" */

//--------------------------------------------------------

	_Wait_tHIGH; 										/* wait */
	_WaitTime1us(); 									/* wait *1 */
	iic_scl = 0; 										/* SCL="L" */
	iic_sda_d = 0; 										/* SDA input */
	_WaitTime1us(); 									/* wait *1 */
	
}
/********************************************************
Name : _WaitTime0us
Parameters : None
Returns : None
Description : a 0us wait
********************************************************/
void _WaitTime0us(void)
{
	;
}
/********************************************************
Name : _WaitTime1us
Parameters : None
Returns : None
Description : a 1us wait
********************************************************/
void _WaitTime1us(void)
{											/* +14cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle = 16cycle */
}
/********************************************************
Name : _WaitTime2us
Parameters : None
Returns : None
Description : a 2us wait
********************************************************/
void _WaitTime2us(void)
{
											/* +14cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle */
	asm("nop"); 							/* +1cycle = 32cycle */
}

//--------------------------------------------------------












